/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#include "stdafx.h"
#include "ui.h"
#include "uiDlg.h"
#include "CommunicationSettings.h"

#include "LoglevelSettings.h"
#include "RecoverSettings.h"
#include "About.h"
#include "SyncSettings.h"
#include "pim/ClientSettings.h"
#include "pim/maincpp.h"
#include "shellapi.h"

#include "SynchronizationMessages.h"
#include "tpcshell.h"
#include "Shellapi.h"
#include "aygshell.h"
#include "pim/SettingFunctions.h"
#include "ClientUtil.h"

#include "base/util/utils.h"
#include <windows.h>

#include "comutil.h"
#include "HwndFunctions.h"
#include "notify/timed_msgbox.h"

#include "CustomButton.h"
#include "ClientUtil.h"

#include "MailSettings.h"
#include "DeviceInfo.h"
#include "pim/account.h"
#include "processUtils.h"
#include "Popup.h"
#include "mail/MailAccount.h"
#include "mail/MailSyncSourceConfig.h"

#include <map>

#define ITEMS_FROM_SERVER 20

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

long retValueLastSync=0;
bool isServerConfigured();

int CuiDlg::pixelX = 0;
int CuiDlg::pixelY = 0;

CuiDlg::CuiDlg(CWnd* pParent /*=NULL*/)
: CDialog(CuiDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    setDialogOpened(false);         
    resetSyncVariables(); 
    setInSettings(false);    
    currentItem = 0;

}

bool CuiDlg::isVGA() {
    
    if (pixelX == 0 && pixelY == 0) {

        isVGAScreen(&pixelX, &pixelY);
        //HDC hDC = ::GetDC(NULL);    
        //pixelX = GetDeviceCaps(hDC, HORZRES);
        //pixelY = GetDeviceCaps(hDC, VERTRES);
    }
    if (min(pixelX, pixelY) > 400) {
        return true;
    } else {
        return false;
    }
    
}

/**
* Only for pocket pc QVGA square we have to add some modification to the
* size of the checkbox and some other changes in drawing of
* Recover form (for checkbox)
* SyncSettings form (for checkbox)
* SyncSettingsAdvanced form (for checkbox and radio button and text box for vCalendar)
* PimSettings form (for top line too close to the drop down list
* About form (for the box of the license)
* 
*/
bool CuiDlg::isQVGASquare() {
    
    if (pixelX == 0 && pixelY == 0) {
        isQVGASquareScreen(&pixelX, &pixelY);
        //HDC hDC = ::GetDC(NULL);    
        //pixelX = GetDeviceCaps(hDC, HORZRES);
        //pixelY = GetDeviceCaps(hDC, VERTRES);        
    }
    if (pixelX == 320 && pixelY == 320) {
        return true;
    } else {
        return false;
    }
    
}

void CuiDlg::DoDataExchange(CDataExchange* pDX) {
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST1, lstSources);
}


BEGIN_MESSAGE_MAP(CuiDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE)
    ON_WM_SIZE()
#endif
    ON_COMMAND(IDM_COMM, OnMenuComm)
    //}}AFX_MSG_MAP
    // ON_COMMAND(IDM_LOGLEVEL,                     &CuiDlg::OnMenuLoglevel)
    ON_COMMAND(ID_SYNC,                          &CuiDlg::OnSyncAll)
    ON_COMMAND(ID_MENU_EXIT,                     &CuiDlg::OnMenuExit)
    ON_COMMAND(ID_RECOVER,                       &CuiDlg::OnMenuRecover)
    ON_COMMAND(ID_MENU_CLEANUP,                  &CuiDlg::OnMenuRecover)
    ON_MESSAGE(ID_MYMSG_CONNECTING,              &CuiDlg::OnMsgConnecting)
    ON_MESSAGE(ID_MYMSG_ENDING,                  &CuiDlg::OnMsgEndingSync)
    ON_MESSAGE(ID_MYMSG_ENDING_SOURCE,           &CuiDlg::OnMsgEndingSource)
    ON_MESSAGE(ID_MYMSG_STARTSYNC_ENDED,         &CuiDlg::OnStartsyncEnded)
    ON_MESSAGE(ID_MYMSG_STARTING_SYNC,           &CuiDlg::OnStartingSync)
    ON_MESSAGE(ID_MYMSG_ENDED_SYNC,              &CuiDlg::OnEndedSync)
    ON_MESSAGE(ID_MYMSG_STARTING_SOURCE,         &CuiDlg::OnStartingSource)
    ON_MESSAGE(ID_MYMSG_ITEM_SYNCED_FROM_SERVER, &CuiDlg::OnMsgItemSyncedFromServer)
    ON_MESSAGE(ID_MYMSG_ITEM_SYNCED_FROM_CLIENT, &CuiDlg::OnMsgItemSyncedFromClient)
    ON_MESSAGE(ID_MYMSG_POPUP,                   &CuiDlg::OnMsgPopup)
    ON_MESSAGE(ID_MYMSG_TOTAL_ITEMS,             &CuiDlg::OnMsgTotalItems)
    ON_MESSAGE(ID_MYMSG_OK,                      &CuiDlg::OnOKMsg)
    
    ON_MESSAGE(ID_MYMSG_TOTAL_NEW,               &CuiDlg::OnMsgTotalItemsNew)
    ON_MESSAGE(ID_MYMSG_TOTAL_MOD,               &CuiDlg::OnMsgTotalItemsMod)
    ON_MESSAGE(ID_MYMSG_TOTAL_DEL,               &CuiDlg::OnMsgTotalItemsDel)

    ON_COMMAND(ID_MENU_UPDATE_SW,                &CuiDlg::OnUpdateProcedure)
    ON_COMMAND(ID_MENU_ABOUT,                    &CuiDlg::OnMenuAbout)
    ON_COMMAND(IDABORT,                          &CuiDlg::OnMenuStop)
    ON_COMMAND(ID_SETTINGS_SYNC,                 &CuiDlg::OnMenuSyncSettings)               
    ON_MESSAGE(ID_MYMSG_ACCOUNT_EMAIL_NOT_EXIST, &CuiDlg::OnAccountEmailNotExisting)                
    ON_MESSAGE(ID_MYMSG_ACCOUNT_EMAIL_CREATED,   &CuiDlg::OnAccountEmailCreated)
    
    ON_MESSAGE(ID_MYMSG_STARTING_DOWNLOAD_ATT,   &CuiDlg::OnStartingDownloadAttachment)
    ON_MESSAGE(ID_MYMSG_ENDING_DOWNLOAD_ATT,     &CuiDlg::OnEndingDownloadAttachment)

    ON_MESSAGE(ID_MYMSG_EXIT_APP_TIMEOUT,        &CuiDlg::OnExitTimedout)
    
    //
    // for the go to 
    //
    ON_COMMAND(ID_MENU_GOTO_APP,                 &CuiDlg::OnGotoApp)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT,       &CuiDlg::OnGotoAccount)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT1,      &CuiDlg::OnGotoAccount1)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT2,      &CuiDlg::OnGotoAccount2)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT3,      &CuiDlg::OnGotoAccount3)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT4,      &CuiDlg::OnGotoAccount4)
    ON_COMMAND(ID_MENU_GOTO_EMAIL_ACCOUNT5,      &CuiDlg::OnGotoAccount5)
	
    //
    // for the sync/enable
    //
	ON_COMMAND(ID_MENU_SYNC_ENABLE,              &CuiDlg::OnSyncEnableSource)
                    
    ON_WM_CLOSE()

    ON_MESSAGE(ID_MYMSG_SOURCE_STATE,            &CuiDlg::OnMsgSourceState)
	ON_MESSAGE(ID_MYMSG_ESS_STOP,                &CuiDlg::checkEmailSlowSync)
    ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1,        &CuiDlg::OnItemchangedList1)

    ON_WM_ACTIVATE()
    ON_WM_INITMENUPOPUP()   

END_MESSAGE_MAP()


/**
* It deletes a special file created during the installation process to signal
* there is an update in progress. If the user chooses to stop the upgrade of the 
* product, this files remain there and there is no way to remove. So at the start
* of the sync client we remove the file in any way. See setup.cpp for other detail.
*/
void deleteFileForUpdate() {
    DeleteFile(TEXT("\\__uninstall_Fun_plugin__"));
}


class ParamsForUpdate {
public:
    CuiDlg& dialogWnd;
    bool manual;

    ParamsForUpdate(CuiDlg& wnd, bool val) : dialogWnd(wnd), manual(val) {};
    ~ParamsForUpdate() {};
} ;
 

/**
* Thread that starts after the sync of the credential if there is 
* an update available
*/
static DWORD WINAPI updateSettingsProcedureWorker(LPVOID lpv) {
    Sleep(1000);
    ParamsForUpdate* p = (ParamsForUpdate*)lpv;         
    int ret = updateProcedure(p->dialogWnd.GetSafeHwnd(), false);       
    return 0;
}

static DWORD WINAPI updateProcedureWorker(LPVOID lpv) {
    
    ParamsForUpdate* p = (ParamsForUpdate*)lpv;
    SetCursor(LoadCursor(NULL, IDC_WAIT));
    int ret = updateProcedure(p->dialogWnd.GetSafeHwnd(), p->manual);
    SetCursor(LoadCursor(NULL, IDC_ARROW)); 

    return 0;
}

void CuiDlg::OnUpdateProcedure() {      
      
    LOG.info("User requested software update");

    ParamsForUpdate* p = new ParamsForUpdate(*this, true);
    if ( !CreateThread(NULL, 0, updateProcedureWorker, (LPVOID)p, 0, NULL) ) {
        LOG.error("OnUpdateProcedure Error creating updateProcedureWorker thread.");           
    }
}


static DWORD WINAPI removedOneWaySyncUpgradeActionProcedure(LPVOID lpv) {
    
    CString s1;
    s1 = getLocalizationUtils()->getLocalizationString(IDS_ONE_WAY_REMOVAL_1);
    s1.Append(L" ");
    s1.Append(getLocalizationUtils()->getLocalizationString(IDS_ONE_WAY_REMOVAL_2));
    s1.Append(L" ");
    s1.Append(getLocalizationUtils()->getLocalizationString(IDS_ONE_WAY_REMOVAL_3));
        
    ParamsForUpdate* p = (ParamsForUpdate*)lpv;
    int ret = 0;

#ifdef WIN32_PLATFORM_PSPC     
    Sleep(1000);
    Popup pop;
    pop.m_bFullScreen = 1;
    pop.setBigMessageOnlyOk(true);
    pop.setTitle(getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT));
    pop.setMessage(s1);
    pop.setbutton1(getLocalizationUtils()->getLocalizationString(IDS_BUT_OK)); 
    INT_PTR result = pop.DoModal();
    return ret;
#endif

#ifdef WIN32_PLATFORM_WFSP    
    
    TimedMessageBox(p->dialogWnd.GetSafeHwnd(), s1, 
        getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), 
        MB_OK, INFINITE);
    return ret;
    
#endif    
}

void CuiDlg::RemovedOneWaySyncUpgradeAction() {      
    
    int flag = -1;
    bool found = false;
    for (int i = 0; i < lstSources.getCountItem(); i++) {
        int id = lstSources.indexToId(i);
        if (!isPIMSource(id)) {
            continue;
        }
        CExtItem* item = lstSources.getItem(id);         
        unsigned long last = item->getSourceConfig()->getLast();
        if (last == 2) {
            item->getSourceConfig()->setLast(0);  
            getRegConfig()->saveWinSourceLastTimeStampToExport(item->getSourceName().c_str());
            found = true;
        }        
    }      
         
    if (found) {
        ParamsForUpdate* p = new ParamsForUpdate(*this, true);
        if ( !CreateThread(NULL, 0, removedOneWaySyncUpgradeActionProcedure, (LPVOID)p, 0, NULL) ) {
            LOG.error("OnUpdateProcedure Error creating updateProcedureWorker thread.");           
        }
    }
    
}


/**
* set log level to debug and store the current log level.
*/ 
void CuiDlg::setDebugLogLevel() {
    setOriginalLogLevel(getRegConfig()->getClientConfig().getLogLevel());
    if (getOriginalLogLevel() != LOG_LEVEL_DEBUG) {
        getRegConfig()->getClientConfig().setLogLevel(LOG_LEVEL_DEBUG);
        getRegConfig()->setClientDirty(CS_DIRTY_DEVICE_CONFIG);
        getRegConfig()->saveDirty();
    }
}

void CuiDlg::restoreLogLevel() {
    if (getOriginalLogLevel() != LOG_LEVEL_DEBUG) {
        getRegConfig()->getClientConfig().setLogLevel(getOriginalLogLevel());
        getRegConfig()->setClientDirty(CS_DIRTY_DEVICE_CONFIG);
        getRegConfig()->saveDirty();
    }        
}

void CuiDlg::OnInitMenuPopup(CMenu *pPopupMenu, UINT nIndex, BOOL bSysMenu) { 
           
    bool gotoMenu = false;
    //
    // insert the contextual item menu to go to the corrispondent 
    int index = lstSources.GetCurSelItem();
    if (index != -1 && nIndex == 0) {
        int id = lstSources.indexToId(index);
        CString gotoApp; gotoApp.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_GOTO);
		CString syncCommand; 
        CString item;
        pPopupMenu->GetMenuString(1, item, MF_BYPOSITION);
        if (item.Find(gotoApp) != -1) { // string found: there is already a menu Goto 
            
			pPopupMenu->RemoveMenu(0, MF_BYCOMMAND | MF_BYPOSITION); // remove sync/enable
            pPopupMenu->RemoveMenu(0, MF_BYCOMMAND | MF_BYPOSITION); // remove goto
            pPopupMenu->RemoveMenu(0, MF_BYPOSITION | MF_SEPARATOR); // remove separator
        }   
        
        CString source;
        source = lstSources.getItemName(id);  
        if (lstSources.isEnabledItem(id)) {
            syncCommand.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_SYNC); 
        } else {
            syncCommand.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ENABLE); 
        }

        gotoApp += source;
		syncCommand += source;
		pPopupMenu->InsertMenu(0, MF_BYCOMMAND | MF_BYPOSITION, ID_MENU_SYNC_ENABLE, syncCommand); 
        //
        // insert the menu of the goto to create the submenu for different email account.
        // if the email is only one, there is only a submenu
        if (id == SOURCE_MAIL) {
            accountNames.clear();
            ClientSettings* cs = getRegConfig();            
            MailSyncSourceConfig* mssc = cs->getMailSyncSourceConfig(false);
            ArrayList al = mssc->getMailAccounts();  
            CString accountMail(TEXT(""));

            if (al.size() >= 1)  {              
                HMENU hSubMenu = CreatePopupMenu();
                            
                for (int i = 0; i< al.size(); i++){
                    accountMail = TEXT("");
                    MailAccount* ma = (MailAccount*)al[i];                    
                    accountMail += ma->getName();

                    if (al.size() == 1) {                        
                        pPopupMenu->InsertMenu(1, MF_BYCOMMAND | MF_BYPOSITION, 
                                        ID_MENU_GOTO_EMAIL_ACCOUNT, gotoApp);

                    } else {

                        switch (i) {
                            case 0:
                                AppendMenu(hSubMenu, MF_STRING | MF_BYCOMMAND, 
                                    ID_MENU_GOTO_EMAIL_ACCOUNT, accountMail);     
                                break;
                            case 1:
                                AppendMenu(hSubMenu, MF_STRING | MF_BYCOMMAND, 
                                    ID_MENU_GOTO_EMAIL_ACCOUNT1, accountMail);     
                                break;
                            case 2:
                                AppendMenu(hSubMenu, MF_STRING | MF_BYCOMMAND, 
                                    ID_MENU_GOTO_EMAIL_ACCOUNT2, accountMail);     
                                break;
                            case 3:
                                AppendMenu(hSubMenu, MF_STRING | MF_BYCOMMAND, 
                                    ID_MENU_GOTO_EMAIL_ACCOUNT3, accountMail);     
                                break;
                            default:
                                AppendMenu(hSubMenu, MF_STRING | MF_BYCOMMAND, 
                                    ID_MENU_GOTO_EMAIL_ACCOUNT, accountMail);     
                                break;
                        }
                    }
                    accountNames.push_back(accountMail);
                } 
                if (al.size() > 1) {  
                    // if size == 1 the menu item was already inserted in the step before
                    pPopupMenu->InsertMenu(1, MF_POPUP | MF_BYPOSITION, (UINT)hSubMenu, gotoApp);                
                }
            } else {
                pPopupMenu->InsertMenu(1, MF_BYCOMMAND | MF_BYPOSITION | MF_GRAYED, 
                                        ID_MENU_GOTO_EMAIL_ACCOUNT, gotoApp);
                
            }
        } else { // other sources
        pPopupMenu->InsertMenu(1, MF_BYCOMMAND | MF_BYPOSITION, ID_MENU_GOTO_APP, gotoApp); 
        }
        pPopupMenu->InsertMenu(2, MF_BYPOSITION | MF_SEPARATOR, 0, gotoApp);
        gotoMenu = true;
    }    
    
    int position = 3;
    if (gotoMenu) { position = 6; }

    CString updateMenuItemString; updateMenuItemString.LoadString(getLocalizationUtils()->getLocaleResource(),IDS_UPDATE_SOFTWARE);
    CString item; pPopupMenu->GetMenuString(position, item, MF_BYPOSITION);                
    if (isNewSwVersionAvailable()) {
        if (item != updateMenuItemString) {
            pPopupMenu->InsertMenu(position, MF_BYCOMMAND | MF_BYPOSITION, ID_MENU_UPDATE_SW, updateMenuItemString);
        }
    } else {
        if (item == updateMenuItemString) {
            pPopupMenu->RemoveMenu(position, MF_BYCOMMAND | MF_BYPOSITION);
        }
    }


}

void CuiDlg::OnGotoApp() {    
    int index = lstSources.GetCurSelItem();
    if (index != -1) {
        int id = lstSources.indexToId(index);
        bool ret = gotoApplication(id);
    }
    return;
}

void CuiDlg::OnGotoAccount() {   
    CString name = accountNames[0];
    bool ret = gotoAccount(name);   
    return;
}
void CuiDlg::OnGotoAccount1() {   

    CString name = accountNames[1];
    bool ret =  gotoAccount(name);
    return;
}

void CuiDlg::OnGotoAccount2() {   
    
    CString name = accountNames[2];
    bool ret =  gotoAccount(name);
    return;
}

void CuiDlg::OnGotoAccount3() {   
    
    CString name = accountNames[3];
    bool ret =  gotoAccount(name);
    return;
}

void CuiDlg::OnGotoAccount4() {   
    
    CString name = accountNames[4];
    bool ret =  gotoAccount(name);
    return;
}
void CuiDlg::OnGotoAccount5() {   
    
    CString name = accountNames[5];
    bool ret =  gotoAccount(name);
    return;
}

void CuiDlg::OnSyncEnableSource() {    
    int index = lstSources.GetCurSelItem();
    return SelectSource(index, false);
}

LRESULT CuiDlg::checkEmailSlowSync( WPARAM wParam, LPARAM lParam){
    // set the value that comes from the check in startsync.exe
    getRegConfig()->getServerConfig().setSmartSlowSync(wParam);
    if (getShowEmailSlowSyncPopup()){
        CString s1;
        if(wParam == 2) {
            s1 = s1 = getLocalizationUtils()->getLocalizationString(IDS_CODE_NETWORK_ERROR_2007);
            TimedMessageBox(GetSafeHwnd(), s1, 
                getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), MB_OK | MB_ICONHAND, INFINITE);
        } else { // since 8.5 it is 0
            s1 = getLocalizationUtils()->getLocalizationString(IDS_SESLOWSYNC);
            TimedMessageBox(GetSafeHwnd(), s1, 
                getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), MB_OK | MB_ICONHAND, INFINITE);
            setShowEmailSlowSyncPopup(false);            
        }
    }
    return 0;
}

void CuiDlg::OnMenuComm()
{
    // set log level to debug to see all the authentication process
    setDebugLogLevel();
    
    setInSettings(true);
    CCommunicationSettings wndCommSett;
    wndCommSett.setIsFromMainMenu(true);        
    INT_PTR result = wndCommSett.DoModal();   

    restoreLogLevel();

    // it returns 1 if the sync process has aborted
    if (result == 1) {
        OnStartsyncEnded(NULL, (LPARAM) -20 );
        setSyncStarted(false);
    }   
   
    setInSettings(false);
    if(isSyncStarted()){
        CreateMenuBar(IDM_STOP);
    }
    this->Invalidate();
}    

BOOL CuiDlg::OnInitDialog() {

    // init the variable that needs to show the popup the client
    // point to a server that is not patched
    setShowEmailSlowSyncPopup(true);
    
    // it is used to decide if reset the counter of the total item.
    resetTheItem = false;
    // it is used to populate the message without the default message
    messageToWrite = "";

    CString s1;
    s1.LoadString(getLocalizationUtils()->getLocaleResource(),IDS_FUNAMBOL); SetWindowText(s1);
    CDialog::OnInitDialog();
    LOG.setLevel(getLOGLevel());
    AfxGetMainWnd()->EnableWindow();
    // init settings
    ClientSettings* cs = getRegConfig();
        
    deleteFileForUpdate();
    
    try {
        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);			// Set big icon
        SetIcon(m_hIcon, FALSE);		// Set small icon
    }
    catch(...) {
        LOG.error("uiDlg: can't set application icon.");
    }

     // try to set the font used in main window
    try {
        LOGFONT lf;
        memset(&lf, 0, sizeof(LOGFONT));
        HFONT hFont = (HFONT) GetStockObject(SYSTEM_FONT);
        GetObject(hFont, sizeof lf, &lf);
        lf.lfWeight = FW_BOLD;
        lf.lfHeight += FONT_HEIGHT_OFFSET;
        VERIFY(lstSources.fontBold.CreateFontIndirect(&lf));
    }
    catch(...) {
        LOG.error("uiDlg: can't set main screen font.");
    }

    // check if another sync is in progress
    if(checkStartSync() != 0) {
        CreateMenuBar(IDM_STOP);        
        setSyncStarted(true);
        lockPanes();
    } else {
        CreateMenuBar(IDR_MENU_MAIN);               
        setSyncStarted(false);
    }    
    
    //
    // init all the controls that are added to the list of sources
    //
    initSyncControls();
    lstSources.SetItemState(0, LVIS_SELECTED, LVIF_STATE);

    CString user;       user = getRegConfig()->getAccessConfig().getUsername();
    CString password;   password = getRegConfig()->getAccessConfig().getPassword();

    string syncConfig = getRegConfig()->getToSyncConfiguration();
    CalculateSize();

    
    if( (!(isServerConfigured())) || user.IsEmpty() || password.IsEmpty() || syncConfig == "1"){
                
        // set log level to debug to see all the authentication process
        setDebugLogLevel();

        lstSources.ShowWindow(SW_HIDE);                
        
        setInSettings(true);
        CCommunicationSettings commSettings;
        CString msg;

        if (syncConfig != "1" || user.IsEmpty() || password.IsEmpty()) {
            msg.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ERROR_ENTER_CREDENTIALS);
            commSettings.showMessage(msg);
        }
        INT_PTR result = commSettings.DoModal();
        
        lstSources.ShowWindow(SW_NORMAL);       
        restoreLogLevel();

        setInSettings(false);
        return TRUE;

    }

    HWND h = ::FindWindow(NULL, getLocalizationUtils()->getLocalizationString(IDS_DOWNLOADING_TITLE));
    if (h) {
        OnStartingDownloadAttachment(0, SOURCE_MAIL);
    }

    // Clean the picture's last error code if = 420 (full quota).
    // This is done to re-enable push/scheduled syncs of pictures after a
    // client restart (now), even if last time quota was exceeded.
    resetSourceError420(SOURCE_PICTURES);
    cs->saveWinSourceLastError(SOURCE_NAME_PICTURE);
    
    RemovedOneWaySyncUpgradeAction();

    //this is set a true the first time to prevent not refresh
    //the date in on activate function before OnInitDialog 
    setDialogOpened(true);
    
    return TRUE;
}
//////////////////////////////////////////////////////////////////////////

void CuiDlg::CalculateSize(){
    
    int resId = IDD_UI_DIALOG;
    CRect rect;
    int panesHeight = 0;
    int panHeightMin = 25, panHeightMax = 30; // min and max source panel height for all screen size
    int numberSources = lstSources.getCountItem();
    int moltiplicator = 1;
    if (isVGA()) {
        moltiplicator = 2;
    }
    if (numberSources == 0) {
        return;
    }           
    
    GetClientRect(&rect);
    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));                        

    lstSources.setItemWidth(rect.Width());
    panesHeight = (int)rect.Height()/numberSources;
    panHeightMin *= moltiplicator;
    panHeightMax *= moltiplicator;

    panesHeight = min(panesHeight, panHeightMax);
    panesHeight = max(panesHeight, panHeightMin);                
    
    /*
    * This check is only for smartphone size device that has
    * small screen size 176x220
    */
    int x_screen_size = GetSystemMetrics(SM_CXSCREEN);
    if (x_screen_size == 176) {
        panesHeight = 25;
    }

    LOG.setLevel(getRegConfig()->getDeviceConfig().getLogLevel());
    LOG.debug("CalculateSize - num sources = %i -> panes height = %i", numberSources, panesHeight);

    lstSources.setItemHeight(panesHeight);
    // stretch the list to cover all client area        
    lstSources.SetWindowPos(GetActiveWindow(),0,0, rect.Width(), rect.Height(),
        SWP_SHOWWINDOW );

    // Recalculate the main logo position.   
    // @todo: find how do it
    // if (!showNoteSource && !showBriefcaseSource) {
    //     lstSources.calculateMainLogoPosition();
    // }


    lstSources.Invalidate();
}


void CuiDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/) {

    CalculateSize();
    
}

void CuiDlg::OnSyncAll() {

    if (!lstSources.getIsLocked()) {
        lockPanes();
    }
    //
    // start a sync of all enabled sources
    //
    lstSources.setStateToAll(ITEM_STATE_TO_SYNC, true);
    lstSources.SetItemState(lstSources.GetCurSelItem(), 0, LVIS_FOCUSED);    
    setFirstSourceToSync();
    StartSync(TEXT("manual"));
}

/*
* OnClose function can be called also by the OS when it needs more resources
*/
void CuiDlg::OnClose() {    
    EndDialog(0);
}

/*
* It is called from the Menu->Close. To keep the similar behaviour since
* previous version, it check if there is the sync process running. If so, it 
* doesn't save the config, otherwise it does. Anyway, the function doesn't
* stop the sync if running
*/
void CuiDlg::OnMenuExit() {            
        
    if (checkStartSync() == 0) { // no sync in progress -> save the config
        getRegConfig()->saveDirty();
        // remove ico that could be appended
        startProgram(SYNCAPP, TEXT("removeNotif"));
    }
    EndDialog(0);
    
}

void CuiDlg::OnMenuRecover()
{
    CRecoverSettings wndRecover;
    // TODO: workaround for isInSettings
    setInSettings(true);
    INT_PTR result = wndRecover.DoModal();
    setInSettings(false);
    if(isSyncStarted()){
        CreateMenuBar(IDM_STOP);
    }
     // Just to be sure...
    if (result == RECOVER_SYNC_STARTED) {
        SetCursor(LoadCursor(NULL, IDC_ARROW));
    }

    lstSources.refreshSourceConfig();
    lstSources.refreshSourcePanes();
                
    //
    // this is to prevent to loose the push that maybe are come
    // during the cleanup process
    // 
    wchar_t** queue = readQueueList();
    if (queue) {        
        wstring cmdLine(TEXT("manual"));
        for (int count = 0; queue[count] != NULL; count++) {     

            if (count == 0) { cmdLine += L" "; }
            else            { cmdLine += L","; }
            cmdLine += queue[count];                       
        
        } 
        delete [] queue;        
        startProgram(SYNCAPP, cmdLine.c_str());
    }    
    
    setInSettings(false);
        
}

/**
* Called at the end of the sync to refresh the config and show the right labels on
* the main panel
*/
LRESULT CuiDlg::OnStartsyncEnded(WPARAM, LPARAM syncResult) {
    //LOG.debug("CuiDlg::OnStartsyncEnded (result = %d)");
    
    CString s1(""), message("");
    int ret = 0;
    ClientSettings* cs = getRegConfig();
    LOG.setLevel(cs->getDeviceConfig().getLogLevel());

    lstSources.stopAnim(currentSource);
    lstSources.stopMainLogo();
    lstSources.refreshSourceConfig();       

    if(!isInSettings()){
        CreateMenuBar(IDR_MENU_MAIN);        
    }

    retValueLastSync = syncResult;
    setSyncStarted(false);

    // stop sync icon animation
    for(int i=0; i<lstSources.GetItemCount(); i++){
        lstSources.stopAnim(lstSources.indexToId(i));
    }

    if( (retValueLastSync == 0) || (retValueLastSync == 10003) ||
        (retValueLastSync == -20) ||  (retValueLastSync == -6) ){  
            // for these errorcodes we don't display error message
    }
    else if (retValueLastSync == ERR_SOURCE_NOT_FOUND_HIDDEN) {
        // Code 2100 = "config" source not found on the Server.
        // It's an old Server, that doesn't support config sync. 
        // Don't display messages and disable the source "config"
        // so we won't do config sync again, when UI params are modified.
        LOG.info("configuration syncsource not found on the Server (code 404).");
        LOG.debug("Config syncmode is now set to 'none'.");
        SyncSourceConfig* ssc = cs->getSyncSourceConfig("config");
        if (ssc) {
            ssc->setIsEnabled(false);
            cs->setClientDirty(CS_DIRTY_SOURCE_ENABLED);
            cs->saveDirty();
        }
    } else if (retValueLastSync == ERR_HTTPS_INVALID_CA) {
        // In this section we want to handle errors that can iteracts with the user
        // currently the user is asked to accept the https certificate
        SetCursor(LoadCursor(NULL, IDC_ARROW));
        message = SyncErrorMsg(retValueLastSync);

        HwndFunctions::closePreviousMsgBox();          
        HWND wndFocus;
        if (isInSettings()) {
            wndFocus = getCommSettingsHwnd();
        } else {
            wndFocus = GetSafeHwnd();
        }
        ret = TimedMessageBox(wndFocus, message, 
                                  getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT),
                                  MB_YESNO | MB_ICONQUESTION | MB_APPLMODAL, INFINITE);
        ::SetActiveWindow(wndFocus);
        
        if (ret == IDYES) {
            cs->setClientDirty(CS_DIRTY_ACCESS_CONFIG);
            cs->setSSLVerifyServerCS(VALUE_DISABLE); 
            cs->saveDirty();
            LOG.debug("uiDlg: the user accepted to get the certificate not trusted. Disable the security");
        } else {            
            LOG.debug("uiDlg: the user don't accept to get the certificate not trusted");
        }

        goto finally;

    }else if(retValueLastSync == 599){
        // For smartphones, we don't want a waiting cursor over the msgbox.
        SetCursor(LoadCursor(NULL, IDC_ARROW));
        OnAccountEmailNotExisting(NULL, NULL);
        goto finally;
    }else {
        // For smartphones, we don't want a waiting cursor over the msgbox.
        SetCursor(LoadCursor(NULL, IDC_ARROW));

        message = SyncErrorMsg(retValueLastSync);
        HwndFunctions::closePreviousMsgBox();
        HWND wndFocus;
        if (isInSettings()) {
            wndFocus = getCommSettingsHwnd();
        } else {
            wndFocus = GetSafeHwnd();
        }

        TimedMessageBox(wndFocus, message, getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT),
            MB_OK | MB_ICONHAND | MB_SETFOREGROUND, INFINITE);
        
        ::SetActiveWindow(wndFocus);                
        
    }

    /* run the update procedure to show if there is one available. The check is done only if there
    * aren't any http error or is not a user stop of the sync      
    
    if (!isInSettings() && retValueLastSync >= 0 && retValueLastSync < ERR_TRANSPORT_BASE) {
        //getRegConfig()->readUpdaterConfig();
        if (checkUpdate()) {
            updateProcedure(GetSafeHwnd(), false);
        }
    }
    */
finally:

    // Checks if some source should be shown/hidden (i.e. pictures)
    refreshSyncControls();

    resetSyncVariables();     
    lstSources.SetItemState(lstSources.GetCurSelItem(), 0, LVIS_FOCUSED);
    unlockPanes();

    // for the case of scheduled sync when the user is in a config window
    if(!isInSettings()){
        lstSources.refreshSourcePanes();
    }

    if(!isSyncCanceled()) {
        lstSources.setStateToAll(ITEM_STATE_OK);
    }

    return ret;
}

void CuiDlg::resetSyncVariables() {

    sourceEnds      = 0;
    sourceBegins    = 0;
    setFirstSourceId(-1);
    currentSource   = 0;
    resetCurrentItem = true;
    totalItems      = 0;
    lastItem        = 0;       
}


/**
* From the maincpp it signals which source is the first
*/
LRESULT CuiDlg::OnStartingSync(WPARAM wParam, LPARAM lParam) {
    //LOG.debug("CuiDlg::OnStartingSync (%d, %d)", wParam, lParam);
    
    CString s2;
    if(!isInSettings()){
        HwndFunctions::closePreviousMsgBox();
        CreateMenuBar(IDM_STOP);        
    }
    lockPanes();
    setSyncStarted(true);

    // Starts the timer for the main logo animation
    lstSources.startMainLogo();

    // received start sync message, we check if startsync.exe has given the first source to be synced
    // if wParam !=0, then in lParam we have the id of the 1st source
    if(wParam != 0){
        setFirstSourceId((int)lParam);
    }
    return 0;
}


LRESULT CuiDlg::OnEndedSync(WPARAM wparam, LPARAM lparam) {
    //LOG.debug("CuiDlg::OnEndedSync (currentsource = %d) lparam = %d", currentSource, lparam);

    // This source has ended: stop and refresh tstamp. Must refresh the config to read last tstamps.
    lstSources.refreshSourceConfig();
    lstSources.stopAnim(currentSource);
    lstSources.refreshSourcePane(currentSource);
    return 0;
}



void CuiDlg::OnMenuAbout() {
    
    CAbout wndAbout;
    setInSettings(true);
    INT_PTR result = wndAbout.DoModal();
    setInSettings(false);
    if(isSyncStarted()){
        CreateMenuBar(IDM_STOP);
    }
    lstSources.refreshSourcePanes();
}

void CuiDlg::OnMenuStop() 
{
    int ret = 0;

    // picture sync source can be stopped in ending sync state
    if (currentSource !=  SOURCE_PICTURES) {
        bool syncEnding = getRegConfig()->getEndingSyncState();
          
        if (syncEnding) {
            LOG.info("%s: discarding cancel event on sync ending state", __FUNCTION__);
            return;
        }
    } 

    // If startsync was not running simulate the message.
    // 1 - sync not running
    // 0 - user choosed to stop the sync, we need to call OnStartsyncEnded
    //     to reset the controls
    ret = EndAppQuery(GetSafeHwnd());
    
    if (ret == 0 || ret == 1) {       
        // close the download popup attachment if exists
        HWND h = ::FindWindow(NULL, getLocalizationUtils()->getLocalizationString(IDS_DOWNLOADING_TITLE));        
        ::SendMessage(h, WM_CLOSE, NULL, NULL);  

        setSyncCanceled(true);
        lstSources.setCanceledState(currentSource);     // only the current item! (now we sync 1 source at time)
        if (ret == 0) {
            OnStartsyncEnded(NULL, (LPARAM) -20); // nothing to show...
        } else {
            OnStartsyncEnded(NULL, (LPARAM) -6);    
        }
    } else{
        setSyncCanceled(false);
    }
}   

void CuiDlg::OnMenuSyncSettings() {

    CSyncSettings wndSyncSettings;
    setInSettings(true);
    INT_PTR result = wndSyncSettings.DoModal();
    setInSettings(false);
    if(isSyncStarted()){
        CreateMenuBar(IDM_STOP);
    }
    lstSources.refreshSourcePanes();
    EnableSyncButton(isSyncEnabled());
}

/**
* It signals when a source is going to be synced.  Called by
* SyncSourceListenerClient::syncSourceBegin
* the id is the sourceId. 
*/
LRESULT CuiDlg::OnStartingSource(WPARAM, LPARAM id) {
    //LOG.debug("CuiDlg::OnStartingSource (id = %d, current = %d)", id, currentSource);
    
    CString s1, s2;
    bool changed = false;
    if (!lstSources.getIsLocked()){
        lockPanes();
    }

    if (currentSource != id) {
        lstSources.stopAnim(currentSource);
        currentSource = id;
        changed = true;
    }

    if(!(sourceBegins & (int)pow(2.0, currentSource))){

        // set the bit for the current source to know that for it we have received a Sync Source Ended event
        sourceBegins |= (int) pow(2.0, currentSource);

        CString msg;
        msg.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CHECKING);
        msg += " ";
        s1 = lstSources.getItemElementName(id);

        msg += s1;
        lstSources.setText(id, msg);
    };

    // if source fails without sending a message that it has finished
    // then we send it ourselves
    if(lstSources.getIsSyncing(currentSource)){
        OnMsgEndingSource(NULL, NULL);
    }

    // if the source fails without sending 'Starting' message
    //s1 = lstSources.getText(currentSource);
    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CONNECTING); 
    s2 = "("; s2 += s1; s2+= ")";
    s1 = lstSources.getText(getFirstSourceId());
    if(s1.Compare(s2) == 0){
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_FAILED);
        lstSources.setText(getFirstSourceId(), s1);
    }

    currentItem = 0;
    lstSources.setIsSyncing(currentSource, true);
    lstSources.SetCurSelItem(lstSources.idToIndex(currentSource));
    if (changed) {
        lstSources.startAnim(currentSource);
    }

    return 0;
}

LRESULT CuiDlg::OnMsgItemSyncedFromServer(WPARAM id, LPARAM lParam) {

    OnMsgItemSynced(id, lParam, false);
    return 0;
}

LRESULT CuiDlg::OnMsgItemSyncedFromClient(WPARAM id, LPARAM lParam) {

    OnMsgItemSynced(id, lParam, true);
    return 0;
}

// not a WM_APP message handler
void CuiDlg::OnMsgItemSynced(WPARAM id, LPARAM lParam, bool fromClient) {    
    
    CString msg("");
    CString s1;

    if(!isSyncStarted()) {
        return;
    }

    if (resetTheItem) {
        resetTheItem = false;
        currentItem = 0;
    }
    currentItem++;

    if( ((id > 0) && (currentSource != id)))  // extra check
    {
        resetCurrentItem = true;
        lastItem = 0;        
    };

    CString s2; s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_UPDATES);

    if(fromClient) {
        if (messageToWrite == "") {
            s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_SENDING);
            s1 += " ";
            s1 += s2;
        } else {
            s1 = messageToWrite;            
        }
        msg += s1; 

    } else {
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_RECEIVING);
        msg +=s1; msg+=" ";
        msg += s2;
    }
    
    if((!resetCurrentItem) && (lParam != 0))  // the server sent more valid noc's for the same source
        currentItem = lastItem + lParam;    

    if(msg == "") {
        goto finally;
    }
    msg += " ";

    char* v = ltow(currentItem);
    msg += v;
    delete [] v; v = NULL;

    if((totalItems != -1) && (currentItem <= totalItems)) {
        msg += "/";
        char* v = ltow(totalItems);
        msg += v;
        delete [] v; v = NULL;
    }
    lstSources.setText(id, msg);

finally:
    return;
}


/**
* wParam = source id
* lParam = number of items
* Sending message
*/
LRESULT CuiDlg::OnMsgTotalItemsNew(WPARAM id, LPARAM nItems) {
 
    resetTheItem   = true;    
    CString s; s.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_SENDING_MESSAGE);
    messageToWrite = s;
    return OnMsgTotalItems(id, nItems);
}

/**
* wParam = source id
* lParam = number of items
* Sending updates
*/
LRESULT CuiDlg::OnMsgTotalItemsMod(WPARAM id, LPARAM nItems) {
 
    resetTheItem   = true;    
    messageToWrite = ""; // substitute with resource string
    return OnMsgTotalItems(id, nItems);
}

/**
* wParam = source id
* lParam = number of items
* Not used at the moment
*/
LRESULT CuiDlg::OnMsgTotalItemsDel(WPARAM id, LPARAM nItems) {
 
    resetTheItem   = true;    
    messageToWrite = "Deleting"; // substitute with resource string
    return OnMsgTotalItems(id, nItems);
}

/**
* It collect the number of total items that are per source
* - the id is the id of the source (MAIL = 0, CONTACT = 1)
* - the totalItemNumber is the max number of items
*/
LRESULT CuiDlg::OnMsgTotalItems(WPARAM id, LPARAM totalItemNumber) {

    CString msg;
    CString s1;
    bool changeLabel = false;
    totalItems = totalItemNumber;

    if (!resetTheItem) {
        messageToWrite = "";
    }
    msg.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_RECEIVING); msg += " ";
    
    s1 = lstSources.getItemElementName(id);

    msg += s1;
    if((msg != "") && changeLabel) {
        SetDlgItemText(IDC_MAIN_MSG, msg);
        lstSources.setText(id, msg);
        if(lstSources.GetNextItem(-1, LVNI_SELECTED ) != id) {
            lstSources.SetItemState(id, LVIS_SELECTED, LVIF_STATE);
        }
    }
    return 0;
}


void CuiDlg::CreateMenuBar(const int id) {

    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO);
    dlgCommandBar.hwndParent = this->GetSafeHwnd();
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = id;
    dlgCommandBar.hInstRes = getLocalizationUtils()->getLocaleResource();
    dlgCommandBar.nBmpId = 0;
    dlgCommandBar.cBmpImages = 0;
    if(!SHCreateMenuBar(&dlgCommandBar)){
        TRACE(_T("Cannot create command bar!\n\n"));
    }
}

LRESULT CuiDlg::OnOKMsg(WPARAM wParam, LPARAM lParam) {

    this->ShowWindow(SW_MINIMIZE);
    return 0;
}

void CuiDlg::OnOK() {

    this->ShowWindow(SW_MINIMIZE);    
}

bool isServerConfigured() {

    ClientSettings* cs = getRegConfig();
    CString s1;
    s1 = cs->getAccessConfig().getSyncURL();
    if(s1.Find(_T("<")) > 0)
        return false;
    else
        return true;

}

// override back key sph
void CuiDlg::OnCancel(){
    // just hide the window
    this->ShowWindow(SW_MINIMIZE);
}


HBRUSH CuiDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor){
    if(pWnd->GetRuntimeClass() == RUNTIME_CLASS(CCustomButton)){
        pDC->SetBkMode(TRANSPARENT);
        pDC->SetBkColor(RGB(255,255,255));
        return (HBRUSH) GetStockObject(HOLLOW_BRUSH);
    }

    HBRUSH hbr = (HBRUSH) CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
    return hbr;
}


void CuiDlg::initSyncControls(){
    CString s1, s2;
    ClientSettings* cs = getRegConfig();

    list<int> sources; 
    list<int>::iterator it;
    string s = cs->getBrandingParams().getSourceOrder();
    sources = listSourceOrder(s);
    
    // these are for the behaviour to show a logo if there are room fot it.
    // the first step is leave as it if not exist note and briefcase
    bool isNote = false, isBriefcase = false;
    
    for (it = sources.begin(); it != sources.end(); it++) {            
        switch (*it) {
                case SOURCE_MAIL: 
                {   
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_EMAIL);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_MAIL);
                    lstSources.addItem(SOURCE_MAIL, s1, SOURCE_NAME_MAIL, 
                        IDI_MAIL, IDI_MAIL_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_MAIL));
                }
                break;
                case SOURCE_CONTACTS:
                {
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CONTACTS);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_CONTACTS);
                    lstSources.addItem(SOURCE_CONTACTS, s1, SOURCE_NAME_CONTACT, 
                        IDI_CONTACTS, IDI_CONTACTS_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_CONTACT));
                }
                break;
                case SOURCE_CALENDAR:
                {
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CALENDAR);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_CALENDAR);
                    lstSources.addItem(SOURCE_CALENDAR, s1, SOURCE_NAME_CALENDAR, 
                        IDI_CALENDAR, IDI_CALENDAR_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_CALENDAR));
   
                }
                break;
                case SOURCE_TASKS:
                {
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_TASKS);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_TASKS);
                    lstSources.addItem(SOURCE_TASKS, s1, SOURCE_NAME_TASK, 
                        IDI_TASKS, IDI_TASKS_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_TASK));

                }
                break;
                case SOURCE_NOTES:
                {
#if defined(WIN32_PLATFORM_PSPC)
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_NOTES);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_NOTES);
                    lstSources.addItem(SOURCE_NOTES, s1, SOURCE_NAME_NOTE, 
                        IDI_NOTES, IDI_NOTES_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_NOTE));
                    isNote = true;
#endif
                }
                break;
                case SOURCE_BRIEFCASE:
                {
                    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_BRIEFCASE);
                    s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_FILES);
                    lstSources.addItem(SOURCE_BRIEFCASE, s1, SOURCE_NAME_BRIEFCASE, 
                        IDI_BRIEFCASE, IDI_BRIEFCASE_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_BRIEFCASE));
                    isBriefcase = true;
                }
                break;
                case SOURCE_PICTURES:
                {
                    // pictures are hidden if Server doesn't support them
                    // anyway, "picture" must be defined in the sourceOrder list to be shown.
                    bool showPictures = cs->checkIfSourceVisible(SOURCE_PICTURES);
                    if (showPictures) {
                        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_PICTURES);
                        s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_PICTURES);
                        lstSources.addItem(SOURCE_PICTURES, s1, SOURCE_NAME_PICTURE, 
                            IDI_PICTURE, IDI_PICTURE_DIM, s2, cs->getWinSyncSourceConfig(SOURCE_NAME_PICTURE));
                    }
                }
                break;


        }        
    }
     // Initialize the main logo only if it's build that doesn't have the note and briefcase
    if (!isNote && !isBriefcase) {
        lstSources.calculateMainLogoPosition();
    }
   
    lstSources.refreshSourcePanes();
    lstSources.Invalidate();
    EnableSyncButton(isSyncEnabled());
}


void CuiDlg::refreshSyncControls() {

    // now only pictures can be dynamically enabled/disabled
    // (scan for all sources in the 'sourceOrder' list to check other sources)

    ClientSettings* cs = getRegConfig();
    bool isSourceVisible   = lstSources.isItemVisible(SOURCE_PICTURES);
    bool isSourceSupported = cs->checkIfSourceVisible(SOURCE_PICTURES);

    if (isSourceVisible && !isSourceSupported) {
        // Remove the source pane
        LOG.info("Removing the pictures source pane");
        lstSources.removeItem(SOURCE_PICTURES);
    }
    else if (!isSourceVisible && isSourceSupported) {
        // Add the source pane
        CString s1, s2;
        int pos = getPositionOfSource(lstSources, SOURCE_PICTURES);

        if (pos > 0) {
            LOG.info("Adding the pictures source pane");
            s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_PICTURES);
            s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_LOWER_PICTURES);
            WindowsSyncSourceConfig* wssc = cs->getWinSyncSourceConfig(SOURCE_NAME_PICTURE);
            
            lstSources.insertItem(SOURCE_PICTURES, pos, s1, SOURCE_NAME_PICTURE, IDI_PICTURE, IDI_PICTURE_DIM, s2, wssc);
        }
    }
    else {
        // nothing to do (no refresh)
        return;
    }

    // refresh UI
    lstSources.refreshSourcePanes();
    EnableSyncButton(isSyncEnabled());

    // this will resize each source pane (number of panes has changed)
    CalculateSize();
}



void CuiDlg::SelectSource(int index, bool question){

    if(index < 0)
        return;

    try {
        CString s1, s2;
        bool refreshPane = false;

        int id = lstSources.indexToId(index);
        string sourceName = lstSources.getSourceName(id);
        if (lstSources.isEnabledItem(id)) {
            lstSources.setState(id, ITEM_STATE_TO_SYNC);
            setFirstSourceToSync(id);
            lstSources.refreshSourcePane(id);
            string command("manual ");
            command += sourceName;
            StartSync(CString(command.c_str()));

        } else {
            int retMsgBox = IDYES;
            if (question) {
                // ask if to enable source
                s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_TEXT_ENABLE_SYNC_FOR); 
                s1 += " ";
                s1 += lstSources.getItemName(id);
                s2.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_TEXT_ITEMS_LOWER); 
                s2 += "?";
                s1 += s2;

                retMsgBox = TimedMessageBox(GetSafeHwnd(), s1, getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT),
                    MB_YESNO | MB_ICONQUESTION | MB_SETFOREGROUND, 10 * 1000);
            }

            if(retMsgBox == IDYES){
                refreshPane = true;
                getRegConfig()->getWinSyncSourceConfig(sourceName.c_str())->setIsEnabled(true);
                getRegConfig()->setClientDirty(getDirtyFlagBySourceName(sourceName));                
                getRegConfig()->saveDirty();
            }
        }
        if(refreshPane){
            lstSources.refreshSourcePane(id);
            EnableSyncButton(isSyncEnabled());
        }

    }
    catch(...) {
        LOG.error("uiDlg: error while selecting source");
    }

    lstSources.UpdateWindow(); 
}

void CuiDlg::StartSync(CString param){
    CString s1;

    int check  = checkStartSync();
    int ret;

    setSyncCanceled(false);

    // check credentials
    ClientSettings* cs = getRegConfig();
    CString user;
    CString password;
    user = cs->getAccessConfig().getUsername();
    password = cs->getAccessConfig().getPassword();

    if(user.IsEmpty() || password.IsEmpty()){
        HwndFunctions::closePreviousMsgBox();
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ERROR_ENTER_CREDENTIALS);
        TimedMessageBox(GetSafeHwnd(), s1, getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), MB_OK | MB_ICONHAND, INFINITE);
        OnStartsyncEnded(0,0); // signal sync ended
        OnMenuComm();
        return; // we return from this so we don't lock the panes
    }
    else
      if (!isServerConfigured()) {
        HwndFunctions::closePreviousMsgBox();
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_TEXT_SET_FUNAMBOL_URL);
        TimedMessageBox(GetSafeHwnd(), s1, getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), MB_OK | MB_ICONHAND, INFINITE);
        OnStartsyncEnded(0,0); // signal sync ended
        OnMenuComm();
        return; // we return from this so we don't lock the panes

    } else if (check == 0) {
        
        // maybe the user deleted the mail account
        // so we refresh the mail and if there is no source to be synced, we return
        if (! isSyncEnabled()) {
            LOG.debug("mail sync is disabled");
            return; // no sync will be performed
        }

        // --------------------------------
        ret = startProgram(SYNCAPP, param);	 // start sync process
        // --------------------------------

        if ( (ret == 0) || (ret == -5) ) {
            HwndFunctions::closePreviousMsgBox();
            s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_TEXT_STARTSYNC_NOT_FOUND);
            TimedMessageBox(GetSafeHwnd(), s1,getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), MB_OK | MB_ICONHAND, INFINITE);
            OnStartsyncEnded(0,0); // signal sync ended
            return; // we return from this so we don't lock the panes
        } else {
            dlgCommandBar.nToolBarId = IDM_STOP;            
            if(!SHCreateMenuBar(&dlgCommandBar)){
                TRACE(_T("Cannot create command bar!"));
                return ;
            }
        }
    };

    lstSources.SetItemState(-1, LVIS_SELECTED, LVIF_STATE);
    // lock panes so they cannot be selected
    lockPanes();
}

void CuiDlg::lockPanes(){
    lstSources.lockList();
}

void CuiDlg::unlockPanes(){
    lstSources.unlockList();
}

BOOL CuiDlg::PreTranslateMessage(MSG* pMsg){

#if defined(WIN32_PLATFORM_PSPC)
    // This msg is received to close the plugin from some task-manager applications
    // like "X-Button" (included in HTC Touch).
    if(pMsg->message == WM_COMMAND) {
        if (pMsg->wParam == 0x0001) {
            OnClose();
            return TRUE;
        }
    }
#endif

#ifdef WIN32_PLATFORM_WFSP
    // only for smartphone, it allows to use the back key to move to the desktop even if the 
    // sync is going on    
    if (HIWORD(pMsg->lParam) == VK_TBACK) {
        return CDialog::PreTranslateMessage(pMsg);
    } 
    if (pMsg->message == WM_KEYDOWN || pMsg->message == WM_KEYDOWN) {
        if (pMsg->wParam == VK_TBACK || pMsg->wParam == VK_ESCAPE) {           
            return CDialog::PreTranslateMessage(pMsg);
        }
    }        
#endif

    bool bProcessed =false;
    if( ((pMsg->message == WM_KEYDOWN) || (pMsg->message == WM_KEYUP) ||
        ((pMsg->message == WM_LBUTTONDOWN) && (pMsg->hwnd == lstSources.GetSafeHwnd())) )  // click in source list
        && (lstSources.getIsLocked()) ){
            bProcessed = true;
            return TRUE;
    };

    if(pMsg->message == WM_KEYDOWN){
        if(pMsg->wParam == VK_RETURN){
            bProcessed = true;
            SelectSource(lstSources.GetNextItem(-1, LVNI_SELECTED));
        }
    };
    
    if(bProcessed)
        return TRUE;
    else
        return CDialog::PreTranslateMessage(pMsg);
}

void CuiDlg::CancelSync(){
    OnMenuStop();
}

/**
* This method is called by the maincpp at the end of the sync. It needs to set the
* status of the sync source in order to have the right value for the refresh pane
*/
// 
LRESULT CuiDlg::OnMsgSourceState(WPARAM wParam, LPARAM lParam) {
    
    lstSources.setSyncSourceState(wParam, lParam);
    return 0;
    
}

void CuiDlg::setFirstSourceToSync() {

    setFirstSourceId(lstSources.getFirstEnabledSource());    
}

LRESULT CuiDlg::OnMsgEndingSource(WPARAM, LPARAM) {
    //LOG.debug("CuiDlg::OnMsgEndingSource");
    //LOG.debug("lastItem=%d, currentItem=%d", lastItem, currentItem);
    
    // sync source ended event
    CString s1;
    lastItem    = currentItem;
    currentItem = 0;

    if(sourceEnds & (int)pow(2.0, currentSource)) {
        // done receiving
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_DONE_RECEIVING);
        lstSources.setText(currentSource, s1);
    } else {
        // done sending
        s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_DONE_SENDING);
        lstSources.setText(currentSource, s1);
        // set the bit for the current source to know that for it we have received a Sync Source Ended event
        sourceEnds |= (int) pow(2.0, currentSource);        
    }
    lstSources.setIsSyncing(currentSource, false);
    return 0;
}

//
LRESULT CuiDlg::OnMsgConnecting(WPARAM, LPARAM){

    CString s1;
    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_CONNECTING);
    int first = getFirstSourceId();
    if(first == -1){
        setFirstSourceToSync();
    }

    // check if we have a valid first source
    if(first != -1){
        lstSources.SetCurSelItem(lstSources.idToIndex(first));
        lstSources.setText(first, s1);
        lstSources.startAnim(first);
        currentSource = first;
    }
    return 0;
}

// 'Ending...' sync message
LRESULT CuiDlg::OnMsgEndingSync(WPARAM, LPARAM) {
    //LOG.debug("CuiDlg::OnMsgEndingSync, currentSource=%d", currentSource);
      bool syncEnding = getRegConfig()->getEndingSyncState();
          
      if (syncEnding) {
          //LOG.debug("setting the text + start anim (syncEnding=true)");
          CString s1;
          s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_ENDING);
          lstSources.setText(currentSource, s1);
          lstSources.startAnim(currentSource);      // why???
    }
    return 0;
}

LRESULT CuiDlg::OnMsgPopup(WPARAM wParam, LPARAM lParam) {

    CString button1;
    CString button2;
    CString button3;
    CString swap;
    CString msg;
    CString buttonval;
    
    getRegConfig()->readUpdaterConfig();
    UpdaterConfig& config = getRegConfig()->getUpdaterConfig();    
    StringBuffer date = config.getReleaseDate();    
    
    if (lParam == IDS_UP_MANDATORY_MESSAGE) { // the string contains a %s that must be formatted
        msg.LoadString(getLocalizationUtils()->getLocaleResource(), lParam);
        int sizeOfString = (msg.GetLength() + 1);
        WCHAR* buffer = new WCHAR[sizeOfString];
        wcsncpy(buffer, msg, sizeOfString);
        wstring formattedDate = formatOnlyDateInLocale(date);            
        WCHAR* currentMsg = new WCHAR[sizeOfString + 100];            
        wsprintf(currentMsg, buffer, formattedDate.c_str());            
        msg = currentMsg;
        delete [] currentMsg;
        delete [] buffer;
    } else {
        msg.LoadString(getLocalizationUtils()->getLocaleResource(), lParam);
    }
    buttonval.LoadString(getLocalizationUtils()->getLocaleResource(), (UINT)wParam);
    int b1 = buttonval.Find(L"*");
    int b2 = buttonval.Find(L"*",b1+1);
    if (b1 == -1 && b2 == -1) {
        button1 = buttonval;
        button2 = L"";
    } else if (b2 == -1){ //just 2 buttons
        button1 = buttonval.Left(b1);
        button2 = buttonval.Right(buttonval.GetLength() - b1 -1);
        button3 = L"";
    } else { //3 buttons
        button1 = buttonval.Left(b1);
        swap = buttonval.Right(buttonval.GetLength() - b1 -1);
        int s = swap.Find(L"*");
        button3 = swap.Right(swap.GetLength() - s -1);
        button2 = swap.Left(s);
    }

    return CMessageBox(msg, button1, button2, button3);    
}

void CuiDlg::OnItemchangedList1(NMHDR* pNMHDR, LRESULT* pResult) {

    NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
    int id = lstSources.indexToId(pNMListView->iItem);

    if(lstSources.isEnabledItem(id)) {
        // Only interested in state changes
        if (pNMListView->uChanged & LVIF_STATE) {
            if (pNMListView->uNewState & LVIS_FOCUSED) {
                //lstSources.setIcon(id, AfxGetApp()->LoadIcon(IDI_ARROWS22A));
                lstSources.setFirstIconArrow(id);
            } else if (pNMListView->uOldState & LVIS_FOCUSED) {
                lstSources.resetSourceIcon(id);
            }
        }
    }
    lstSources.InvalidatePane(id);
    *pResult = 0;
}

void CuiDlg::EnableSyncButton(bool bEnable) {

    HWND hwndMB = SHFindMenuBar (this->GetSafeHwnd());
    TBBUTTONINFO tbi;
    if (!hwndMB) {
        return;
    }

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (hwndMB, TB_GETBUTTONINFO, ID_SYNC, (LPARAM)&tbi);

    if(bEnable) {
        tbi.fsState = TBSTATE_ENABLED;
    }
    else {
        tbi.fsState &= ~TBSTATE_ENABLED;
    }
    ::SendMessage (hwndMB, TB_SETBUTTONINFO, ID_SYNC, (LPARAM)&tbi);
}

bool CuiDlg::isSyncEnabled() {
        
    return (lstSources.getFirstEnabledSource() > -1 ? true : false);
}


void CuiDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized) {

    CDialog::OnActivate(nState, pWndOther, bMinimized);
    if(isDialogOpened() && !isSyncStarted()){
        lstSources.refreshSourcePanes();
        // check if the CP is activated or not. If not it can be restored
        // it is checked only when the flag openUp has true, so when the oninit
        checkCPWorking();
    }
}

LRESULT CuiDlg::OnAccountEmailNotExisting(WPARAM wParam, LPARAM lParam) {
    
    HWND foreground = GetForegroundWindow()->GetSafeHwnd();
    HWND current = this->GetSafeHwnd();

    CString s1;
    s1 = getLocalizationUtils()->getLocalizationString(IDS_NO_EMAIL_NOTIFICATION);

    if (current == foreground) {
        TimedMessageBox(GetSafeHwnd(), s1, 
                getLocalizationUtils()->getLocalizationString(IDS_FUNAMBOL_ALERT), 
                MB_OK | MB_ICONHAND, INFINITE);        
    }
    else {
        LOG.info("%ls", s1.GetBuffer());
    }

    return 0;
    
}

LRESULT CuiDlg::OnAccountEmailCreated(WPARAM wParam, LPARAM lParam) {

    // bitmask: [1, 2, 4, 8]
    int accountsMask = (int)wParam;
    if (accountsMask == 0) {
        return 1;
    }

    // magic: if 4 accounts, the max mask value is 15 -> log(15+1) = 4, then approx at the higher int
    int maxNumAccounts = (int)(log(accountsMask+1) + 1);

    MailSyncSourceConfig* mssc = getRegConfig()->getMailSyncSourceConfig(true);
    if (!mssc) {
        return 1;
    }
    const ArrayList& accounts = mssc->getMailAccounts();
    StringBuffer names;
    int count = 0;      // the number of accounts created


    //
    // Format the names string with new account names, like "first@email, second@email"
    //
    for (int i=0; i<maxNumAccounts; i++) {
        
        // the account bitmask from its index: 0->1, 1->2, 2->4, 4->8,...
        int mask = (int)pow(2, i);
        if (accountsMask & mask) {

            if (accounts.size() > i) {
                MailAccount* account = (MailAccount*)accounts.get(i);   // get the right account
                if (account) {
                    if (count > 0) {
                        names.append(", ");
                    }
                    names.append("\""); 
                    names.append(account->getName()); 
                    names.append("\"");

                    count ++;
                }
            }
        }
    }


    //
    // Format the popup message: different if more than 1 account is created
    //
    CString s1;
    const WCHAR* wnames = toWideChar(names.c_str());
    
    int resourceID = IDS_NEW_ACCOUNT_NOTIFICATION;
    if (count > 1) {
        resourceID = IDS_MANY_NEW_ACCOUNTS_NOTIFICATION;
    }
    s1.FormatMessage(getLocalizationUtils()->getLocalizationString(resourceID), wnames);

    
    //
    // Show the popup
    //
    HWND foreground = GetForegroundWindow()->GetSafeHwnd();
    HWND current = this->GetSafeHwnd();

    if (current == foreground) {
        TimedMessageBox(GetSafeHwnd(), s1, TEXT(APP_NAME), MB_OK | MB_ICONINFORMATION, INFINITE);
    }
    else {
        LOG.info("%ls", s1.GetBuffer());
    }

    return 0;
    
}

/**
* The method is called by startsync to notify that the download of the attachment is started.
* The method disable the UI and allow the user to stop the sync from the main UI of the sync
* client and avoid to be able to start another sync from the main panel
* 
*/
LRESULT CuiDlg::OnStartingDownloadAttachment(WPARAM wParam, LPARAM lParam) {
        
    CString s1;
    if(!isInSettings()){
        HwndFunctions::closePreviousMsgBox();
        CreateMenuBar(IDM_STOP);        
    }
    lockPanes();
    setSyncStarted(true);

    // Starts the timer for the main logo animation
    lstSources.startMainLogo();
   
    setFirstSourceId((int)lParam);    
    
    s1.LoadString(getLocalizationUtils()->getLocaleResource(), IDS_DOWNLOAD_ATTACH_IN_PROGRESS_UI);    
    lstSources.SetCurSelItem(lstSources.idToIndex((int)lParam));
    lstSources.setText((int)lParam, s1);
    lstSources.startAnim((int)lParam);
    currentSource = (int)lParam;    
    
    return 0;
}

/**
* The method is called by startsync at the end of the downloading attachment.
* It refresh the UI with the previous values.
*/
LRESULT CuiDlg::OnEndingDownloadAttachment(WPARAM, LPARAM) {

    lstSources.stopAnim(currentSource);
    lstSources.stopMainLogo();
   
    setSyncStarted(false);
    unlockPanes();
 
    if(!isInSettings()){
        CreateMenuBar(IDR_MENU_MAIN);        
    }
    
    lstSources.refreshSourcePanes();
    return 0;
}


static DWORD WINAPI exitApplicationAfterTimeout(LPVOID lpv) {
    Sleep(5000);
    ParamsForUpdate* p = (ParamsForUpdate*)lpv;         
    p->dialogWnd.OnClose();
    return 0;
}

afx_msg LRESULT CuiDlg::OnExitTimedout(WPARAM wParam, LPARAM lParam){            
    
    this->ShowWindow(SW_MINIMIZE);
    ParamsForUpdate* p = new ParamsForUpdate(*this, true);
    if (!CreateThread(NULL, 0, exitApplicationAfterTimeout, (LPVOID)p, 0, NULL) ) {  
        LOG.debug("Error creating thread");
    }        
    return 0;
}