/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#include "stdafx.h"

#include <cfgmgrapi.h>
#include "Tlhelp32.h"
#include "mail.h"
#include "registry.h"
#include "Winbase.h"  //-- for createProcess
#include "winreg.h"   //-- for registry key reading
#include "spds/DataTransformerFactory.h"
#include "spds/B64Encoder.h"
#include "spds/B64Decoder.h"
#include "spds/DESEncoder.h"
#include "spds/DESDecoder.h"
#include "base/stringUtils.h"
#include "spdm/constants.h"
#include "spds/constants.h"
#include <cfgmgrapi.h>
#include <mapidefs.h>
#include <mapicode.h>
#include <mapitags.h>
#include <mapix.h>
#include <mapiutil.h>
#include <cemapi.h>
#include "base/util/WString.h"
#define NO_SMARTPHONE TEXT("The version of the Funambol Sync Client you are trying to install is not designed for this device. Please download the Pocket PC version.")
#define NO_POCKET_PC TEXT("The version of the Funambol Sync Client you are trying to install is not designed for this device. Please download the Smartphone version.")
#define TOO_OLD_VERSION TEXT("The version currently installed is too old to be upgraded succesfully. Please remove manually and then try again the installation.")

#define FILE1 TEXT("mails_I")
#define FILE2 TEXT("mails_O")
#define FILE3 TEXT("mails_D")
#define FILE4 TEXT("mails_S")
#define FILE5 TEXT("mails_T")
#define FILE6 TEXT("appointments.dat")
#define FILE7 TEXT("contacts.dat")
#define FILE8 TEXT("notes.dat")
#define FILE9 TEXT("tasks.dat")
#define FILE10 TEXT("briefcase.dat")
#define FILE11 TEXT("favorites.dat")
#define FILE18 TEXT("appOidToReset.dat")
#define FILE19 TEXT("wap_push.txt")


#define FILE12 TEXT("\\AccountLog.txt")
#define FILE13 TEXT("\\synclog.txt")
#define FILE14 TEXT("\\notlstnr.txt")
#define FILE15 TEXT("\\wap_push.txt")
#define FILE16 TEXT("\\wap.txt")
#define FILE17 TEXT("\\syncresults.txt")

// Used to have a different key in the cared and comed edition
// With the value NULL, the default password is used.
// it is define in ClientSettings.h too (because the dll is not linked)
// important: the follow define must be in this way
// PASS_KEY<4 blanks>NULL
#define PASS_KEY    NULL


int ret = 0;

int FileCopy ( const char *src, const char *dst );
int FileCopy ( const wchar_t *src, const wchar_t *dst );

const wchar_t *getProgramPath();
static BOOL IsSmartphoneDevice();
bool checkCredentials();

#if defined(WIN32_PLATFORM_WFSP)
    BOOL isPluginSmartphone = true;
#else
    BOOL isPluginSmartphone = false;
#endif

wchar_t* getTempFileDir() {

    wchar_t* internalPath = new wchar_t[256];
    SHGetSpecialFolderPath(NULL, internalPath, CSIDL_WINDOWS, FALSE);
    wcscat(internalPath, TEXT("\\"));
    wcscat(internalPath, TEXT("tempFunFiles"));
    return internalPath;
}

void createFileForUpdate() {
    FILE* funinstall = fopen("\\__uninstall_Fun_plugin__", "a+");
    fputs ("uninstall", funinstall);
    fclose(funinstall);
}

void deleteFileForUpdate() {

    DeleteFile(TEXT("\\__uninstall_Fun_plugin__"));
}

bool existsFileForUpdate() {
    FILE* f = fopen("\\__uninstall_Fun_plugin__", "r");

    bool ret = false;
    if (f) {
        ret = true;
        fclose(f);
    }
    return ret;
}


BOOL removeFileInDir(const wchar_t* dir) {
    WIN32_FIND_DATA FileData;

    wchar_t internalPath[256];
    wcscpy(internalPath, dir);

    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];

    szNewPath[0] =   0;

    DWORD dwAttrs;
    BOOL fFinished = FALSE;

    wsprintf(filterPattern, TEXT("*.*"));

    wsprintf(toFind, TEXT("%s/%s"), internalPath, filterPattern);

    hFind = FindFirstFile(toFind, &FileData);

    if (hFind != INVALID_HANDLE_VALUE) {

        while (!fFinished) {

            wsprintf(szNewPath, TEXT("%s/%s"), internalPath, FileData.cFileName);

            dwAttrs = GetFileAttributes(szNewPath);

            if (dwAttrs == FILE_ATTRIBUTE_DIRECTORY) { }

            else {
                  DeleteFile(szNewPath);
            }

            if (!FindNextFile(hFind, &FileData)) {
                if (GetLastError() == ERROR_NO_MORE_FILES) {
                    fFinished = TRUE;
                }
                else  {
                    return FALSE;
                }
            }
        }

        FindClose(hFind);
    }
    return true;
}

BOOL isWindowsMobile5() {

    OSVERSIONINFO OSVersionInfo;
    OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&OSVersionInfo);

    if (OSVersionInfo.dwMajorVersion >= 5)
        return true;
    else
        return false;
}

bool backupFiles() {

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;

    const wchar_t* path = getProgramPath();

    CreateDirectory(internalPath, NULL);
    // clean if there are some dirty files
    removeFileInDir(internalPath);

    wchar_t src[255]; wchar_t dst[255];

    wsprintf(src, TEXT("%s\\%s"), path, FILE1);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE1);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE2);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE2);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE3);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE3);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE4);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE4);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE5);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE5);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE6);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE6);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE7);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE7);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE8);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE8);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE9);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE9);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE10);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE10);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE11);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE11);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE18);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE18);

    wsprintf(src, TEXT("%s\\%s"), path, FILE19);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE19);

    FileCopy(src, dst);

    if (internalPath)
        delete [] internalPath;
    return true;
}

// return true for ok
bool backupClientVersion() {
    backupFiles();
    backupRegistryVersion();
    return true;
}

bool existsBackup() {

    // to check for the registry backup
    HKEY key = NULL;
    DWORD res;
    bool ret = false;

    res = RegOpenKeyEx(
            HKEY_LOCAL_MACHINE,
            getFullRegBkp(BASE_ROOT_TREE),
            0,
            NULL,
            &key
            );

    if (key != 0) {
        RegCloseKey(key);
    }

    if (res == ERROR_SUCCESS) {
        ret = true;
    }

    return ret;
}

bool restoreFiles() {

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;
    const wchar_t* path = getProgramPath();

    wchar_t src[255]; wchar_t dst[255];

    wsprintf(dst, TEXT("%s\\%s"), path, FILE1);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE1);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE2);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE2);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE3);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE3);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE4);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE4);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE5);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE5);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE6);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE6);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE7);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE7);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE8);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE8);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE9);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE9);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE10);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE10);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE11);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE11);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE18);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE18);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE19);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE19);
    FileCopy(src, dst);

    if (internalPath)
        delete [] internalPath;
    return true;
}

// return true for ok
bool restoreClientVersion() {

    restoreFiles();
    restoreRegistryVersion();

    return true;
}

bool removeBackupVersion() {

    removeBackupRegistryVersion();

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;
    removeFileInDir(internalPath);
    RemoveDirectory(internalPath); // remove tmp empty dir

    return true;
}

/****************************************************************/
// retrieve the Funambol program path and set it in a static
// buffer. Return the buffer
const wchar_t *getProgramPath()
{
    static wchar_t path[MAX_PATH] = TEXT("");

    HKEY key = NULL;
    long err = 0;
    ULONG dim = 0;
    DWORD type =0;

    wchar_t rpath[MAX_PATH] = TEXT("");
    wsprintf(rpath, BASE_ROOT_TREE, getRegistryRoot());

    RegOpenKeyEx(HKEY_LOCAL_MACHINE,rpath,0,0, &key );

    err = RegQueryValueEx(key, _T("path"),  NULL, NULL, NULL, &dim  );
    if (err == ERROR_SUCCESS)
    {
        if (dim > 0)
        {
            wchar_t *buf = new wchar_t[dim + 1];
            memset(buf, 0, (dim+1)*sizeof(wchar_t));
            err = RegQueryValueEx( key, _T("path"),  NULL, NULL, (UCHAR*)buf, &dim);
            RegCloseKey(key);
            wcscpy(path, buf);
            if(buf) {
                delete [] buf;
            }
        }
        else
            RegCloseKey(key);
    }
    else
    {
        //-- reg value not found
        if (!path[0])
        {
            SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILES , FALSE);
            wcscat(path, TEXT("\\"));
            wcscat(path, PROGRAM_DIR);
        }
    }
    return path;
}

/**
 * start a new process filling up its PROCESS_INFORMATION structure
 * return true for success, false on errors
 */
bool execprogram(const wchar_t *app, const wchar_t *cmdline, PROCESS_INFORMATION* procinfo)
{
    bool ret = false;
    const wchar_t *path = getProgramPath();
    wchar_t *cmd = new wchar_t[wcslen(path) + wcslen(app) + 5];

    wsprintf(cmd, TEXT("%s\\%s"), path, app);

    if (CreateProcess( cmd, cmdline,
                       NULL, NULL, FALSE, 0,
                       NULL, NULL, NULL, procinfo ) ) {
        ret = true;
    }

    if (path) {
        path = NULL;
    }

    if (cmd) {
        delete [] cmd;
    }

    return ret;
}



// left handleservice for backwork compatibility since 8.0
void deregister() {

    // it removes both the schedule things and/or the push
    PROCESS_INFORMATION proc_info;
    DWORD dwWaitRes = 0;
    DWORD timeOut = 10 * 1000; // 10 secs of timeout
    memset(&proc_info, 0, sizeof(proc_info));

    execprogram( _T("startsync.exe"), _T("deregisterForUninstall"), &proc_info);

    dwWaitRes = WaitForSingleObject(proc_info.hProcess, timeOut);

}


void registerPush() {

    PROCESS_INFORMATION proc_info;
    DWORD dwWaitRes = 0;
    DWORD timeOut = 10 * 1000; // 10 secs of timeout
    memset(&proc_info, 0, sizeof(proc_info));

    execprogram( _T("startsync.exe"), _T("register"), &proc_info);

    dwWaitRes = WaitForSingleObject(proc_info.hProcess, timeOut);

}


void restoreNotificationSettings() {

    wchar_t* value = NULL;
    wchar_t rpath[MAX_PATH] = TEXT("");
    wsprintf(rpath, BASE_ROOT_TREE, getRegistryRoot());

    // Start push only if syncUrl and credentials are set
    if (checkCredentials()) {
        value = readPropertyValue(rpath, TEXT("push"));
	    if (value && wcscmp(value, TEXT("0")) != 0) {
	        registerPush();
	    }
	    if (value) { delete [] value; value = NULL; }
    }
}


BOOL deleteFilesInRoot() {
    DeleteFile(FILE12);
    DeleteFile(FILE13);
    DeleteFile(FILE14);
    DeleteFile(FILE15);
    DeleteFile(FILE16);
    DeleteFile(FILE17);
    return true;
}


BOOL deleteFiles() {

    WIN32_FIND_DATA FileData;

    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];
    wchar_t dir       [512];

    BOOL ret = TRUE;
    szNewPath[0] =   0;
    int lung = 0;

    DWORD dwAttrs;

    BOOL fFinished = FALSE;
    wcscpy(dir, getProgramPath());
    wsprintf(filterPattern, TEXT("*.*"));

    wsprintf(toFind, TEXT("%s/%s"), dir, filterPattern);

    hFind = FindFirstFile(toFind, &FileData);

    if (hFind != INVALID_HANDLE_VALUE) {

        while (!fFinished) {

            wsprintf(szNewPath, TEXT("%s/%s"), dir, FileData.cFileName);

            dwAttrs = GetFileAttributes(szNewPath);

            if (dwAttrs == FILE_ATTRIBUTE_DIRECTORY) { }

            else {
                if (   (wcsstr(szNewPath, FILE1) != NULL) ||
                       (wcsstr(szNewPath, FILE2) != NULL) ||
                       (wcsstr(szNewPath, FILE3) != NULL) ||
                       (wcsstr(szNewPath, FILE4) != NULL) ||
                       (wcsstr(szNewPath, FILE5) != NULL) ||
                       (wcsstr(szNewPath, FILE6) != NULL) ||
                       (wcsstr(szNewPath, FILE7) != NULL) ||
                       (wcsstr(szNewPath, FILE8) != NULL) ||
                       (wcsstr(szNewPath, FILE9) != NULL) ||
                       (wcsstr(szNewPath, FILE10) != NULL) ||
                       (wcsstr(szNewPath, FILE11) != NULL) ||
                       (wcsstr(szNewPath, FILE18) != NULL) ||
                       (wcsstr(szNewPath, FILE19) != NULL)
                       ) {

                        DeleteFile(szNewPath);
                }
            }

            if (!FindNextFile(hFind, &FileData)) {
                if (GetLastError() == ERROR_NO_MORE_FILES) {
                    fFinished = TRUE;
                }
                else  {
                    return FALSE;
                }
            }
        }

        FindClose(hFind);
    }

    deleteFilesInRoot();

    return ret;
}

BOOL deleteDirectory() {

    wchar_t dir       [512];
    wcscpy(dir, getProgramPath());
    RemoveDirectory(dir);
    return TRUE;
}

BOOL createDirectory() {

    wchar_t dir       [512];
    wcscpy(dir, getProgramPath());
    CreateDirectory(dir, NULL);
    return TRUE;
}

DWORD getProcessPid(const wchar_t *processName)
{
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;
    DWORD pid = 0;

   HANDLE hSnapshot;

    for (int i = 0; i < 3; i++) {

#if (WINVER > 0x500)
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS | TH32CS_SNAPNOHEAPS, 0); // 0 is however ignored
#else
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored
#endif
        if (hSnapshot == INVALID_HANDLE_VALUE) {
            i++;
        } else {
            break;
        }
        if (i == 3) {
        return 0;
        }
    }

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 0;

    if (wcsstr(lppe.szExeFile, processName) != NULL) {
        pid = lppe.th32ProcessID;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, processName) != NULL ) {
            pid = lppe.th32ProcessID;
            break;
        }

    } while(next);

    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return pid;
}


DWORD checkSyncInProgress() {
    DWORD pid = 0;
    // Try to create the mutex
    HANDLE hMutex = CreateMutex(NULL, TRUE, TEXT("FunSyncInProgress") );
    if(hMutex){
        if(GetLastError() == ERROR_ALREADY_EXISTS){
            pid = getProcessPid( TEXT("startsync.exe") );
        }
        CloseHandle( hMutex );
    }
    return pid;
}

DWORD checkUI() {
    DWORD pid = 0;

    wchar_t value[MAX_PATH] = TEXT("");
    wsprintf(value ,TEXT("%s.exe"),UI_EXECUTABLE_NAME);
    pid = getProcessPid( value );
    return pid;
}
int closeMail() {

    /**
    * Way to close the mail application. It close it gracefully (it should...)
    */
    HWND hwndInbox = FindWindow(_T("Inbox.MainWnd"), NULL);
    if (hwndInbox) {
        SendMessage(hwndInbox, WM_CLOSE, 0, 0);
    }
    Sleep(2000);
    // try to kill if the first part fails
    DWORD out = 0;
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;
    HANDLE hSnapshot;

    for (int i = 0; i < 3; i++) {
#if (WINVER > 0x500)
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS | TH32CS_SNAPNOHEAPS, 0); // 0 is however ignored
#else
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored
#endif
        if (hSnapshot == INVALID_HANDLE_VALUE) {
            i++;
        } else {
            break;
        }
        if (i == 3) {
        return 0;
        }
    }
    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;

    if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        goto exit;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL ) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            goto exit;
        }

    } while(next);

exit:
    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

int closeFunambol() {
    DWORD out = 0;
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;

   HANDLE hSnapshot;

    for (int i = 0; i < 3; i++) {
#if (WINVER > 0x500)
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS | TH32CS_SNAPNOHEAPS, 0); // 0 is however ignored
#else
        hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored
#endif
        if (hSnapshot == INVALID_HANDLE_VALUE) {
            i++;
        } else {
            break;
        }
        if (i == 3) {
        return 0;
        }
    }

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;


    wchar_t value[MAX_PATH] = TEXT("");
    wsprintf(value ,TEXT("%s.exe"),UI_EXECUTABLE_NAME);
    if (wcsstr(lppe.szExeFile, value) != NULL ||
        wcsstr(lppe.szExeFile, TEXT("startsync.exe")) != NULL) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        CloseHandle(hProcess);
        //goto exit;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        wchar_t value[MAX_PATH] = TEXT("");
        wsprintf(value ,TEXT("%s.exe"),UI_EXECUTABLE_NAME);
        if (wcsstr(lppe.szExeFile, value) != NULL ||
            wcsstr(lppe.szExeFile, TEXT("startsync.exe")) != NULL) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            CloseHandle(hProcess);
            //goto exit;
        }

    } while(next);

    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

int FileCopy ( const wchar_t *src, const wchar_t *dst ) {

    char* s = toMultibyte(src);
    char* d = toMultibyte(dst);

    int ret = FileCopy(s, d);

    if (s) { delete [] s; }
    if (d) { delete [] d; }

    return ret;

}
int FileCopy ( const char *src, const char *dst ) {

    int COPY_ERROR  = -1;
    int COPY_OK     =  0;
    int BUFSZ       = 16000;

    char            *buf;
    FILE            *fi;
    FILE            *fo;
    unsigned        amount;
    unsigned        written;
    int             result = COPY_OK;

    buf = new char[BUFSZ];

    fi = fopen( src, "rb" );
    if  (fi == NULL) {
        return COPY_ERROR;
    }

    fo = fopen( dst, "wb" );

    if  ((fi == NULL) || (fo == NULL) ) {
        result = COPY_ERROR;
        if (fi != NULL) fclose(fi);
        if (fo != NULL) fclose(fo);
    }

    if (result == COPY_OK) {
        do {
            amount = fread( buf, sizeof(char), BUFSZ, fi );
            if (amount) {
                written = fwrite( buf, sizeof(char), amount, fo );
                if (written != amount) {
                    result = COPY_ERROR; // out of disk space or some other disk err?
                }
            }
        } // when amount read is < BUFSZ, copy is done
        while ((result == COPY_OK) && (amount == BUFSZ));

        fclose(fi);
        fclose(fo);
    }

    delete [] buf;

    return result;

}

const wchar_t *getWindowsPath() {

    static wchar_t winpath[MAX_PATH] = TEXT("");
    if (!winpath[0]) {
        SHGetSpecialFolderPath(NULL, winpath, CSIDL_WINDOWS , FALSE);
        wcscat(winpath, TEXT("\\"));
    }
    return winpath;
}

void createBriefcaseFolder() {

    /*
    * create a briefcase directory under
    * My Documents and set it by default. It must not be deleted during the uninstall process.
    */
    LPTSTR dir = new WCHAR[256];
    SHGetSpecialFolderPath(NULL,dir, CSIDL_PERSONAL, FALSE);
    wcscat(dir,_T("\\briefcase"));
    CreateDirectory(dir,NULL);

    HKEY key = NULL;
    long err = 0;
    DWORD type =0;

    wchar_t rpath[MAX_PATH] = TEXT("");
    wsprintf(rpath, BASE_ROOT_TREE   TREE_SOURCE_BRIEFCASE, getRegistryRoot());

    RegOpenKeyEx(HKEY_LOCAL_MACHINE,rpath, 0, 0, &key );
    err = RegSetValueEx(key, _T("dir"),  NULL, REG_SZ, (BYTE*)dir, (wcslen(dir)+1)*sizeof(wchar_t));

    RegCloseKey(key);
    delete [] dir;
}


int existsPreviousVersionWithDifferentName(wchar_t* nameToRemove) {

    wchar_t** programs = getChildrenNames();
    int ret = 0;
   // there is nothing installed on the device
    if (programs == NULL)
        return ret;

    int j = 0;
    for (j = 0; programs[j] != NULL; j++) {
        if ((wcsstr(programs[j], OLD_FUN_PLUG_IN_NAME)) != NULL ) {
            wcscpy(nameToRemove, programs[j]);
            ret = 1;  // old version 6.0, 6.5, 7.0
            break;
        }
        // we don't consider the other version anymore

    }

    for (j = 0; programs[j] != NULL; j++) {
        delete [] programs[j];
    }
    delete [] programs;

    if (wcslen(nameToRemove) > 0)
        return ret;
    else
        return 0;

}

/*
 * Returns an integer value rapresenting the build number read from
 * the string version passed (e.g. "6.1.12" -> 60112).
 */
int getBuildNumberFromVersion(const wchar_t* swv) {

    int major=0, minor=0, build=0;
    if (!swv) {
        return 0;
    }
    swscanf(swv, TEXT("%d.%d.%d"), &major, &minor, &build);
    return (major*10000 + minor*100 + build);
}

/*
 * Funambol mail account cleanup functions
 */
enum {
    ePR_ENTRYID,
    ePR_DISPLAY_NAME,
    ePR_CE_UNIQUE_STORE_ID,
    NUM_COLS
    };

// These tags represent the message information we would like to pick up
static SizedSPropTagArray(NUM_COLS, Columns) =
{
    NUM_COLS,
    PR_ENTRYID,
    PR_DISPLAY_NAME,
    PR_CE_UNIQUE_STORE_ID
};


wchar_t* getFunambolAccountId()
{
    HRESULT           hr                = S_FALSE;
    IMAPISession *    pSession          = NULL;
    IMAPITable*       pTable            = NULL;
    SRowSet*          psrs              = NULL;
    IMsgStore*        pStore            = NULL;
    bool              accountFound      = false;
    wchar_t*          guid              = NULL;
    bool              isSessionCreated  = false;

    // First log on to the store.
    if ((hr = MAPILogonEx (NULL, NULL, NULL, NULL, &pSession)) != S_OK) {
        goto FuncExit;
    }

    // Get the message stores table
    if ((hr = pSession->GetMsgStoresTable (MAPI_UNICODE, &pTable)) != S_OK) {
        goto FuncExit;
    }

    if ((hr = pTable->SetColumns((LPSPropTagArray)&Columns, 0)) != S_OK) {
        goto FuncExit;
    }

    while (1) {
        // Get a row
        if ((hr = pTable->QueryRows (1, 0, &psrs)) != S_OK) {
            break;
        }

        // Did we hit the end of the table?
        if (psrs->cRows != 1) {
          break;
        }

        if (psrs->aRow[0].lpProps[ePR_DISPLAY_NAME].ulPropTag == PR_DISPLAY_NAME) {
            wchar_t* displayName = psrs->aRow[0].lpProps[ePR_DISPLAY_NAME].Value.lpszW;

            // check if we've found an account with name 'Funambol'
            if (wcscmp(displayName, DEFAULT_ACCOUNT_NAME) == 0) {
                accountFound = true;
                // Now we get the GUID
                LPGUID pGuid = NULL;

                if (psrs->aRow[0].lpProps[ePR_CE_UNIQUE_STORE_ID].ulPropTag == PR_CE_UNIQUE_STORE_ID) {
                    pGuid = psrs->aRow[0].lpProps[ePR_CE_UNIQUE_STORE_ID].Value.lpguid;
                    guid = new wchar_t[64];
                    memset(guid, 0, 64*sizeof(wchar_t));

                    wsprintf(guid,
                        TEXT("{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}"),
                        pGuid->Data1, pGuid->Data2, pGuid->Data3,
                        pGuid->Data4[0], pGuid->Data4[1],
                        pGuid->Data4[2], pGuid->Data4[3],
                        pGuid->Data4[4], pGuid->Data4[5],
                        pGuid->Data4[6], pGuid->Data4[7]);
                }
            }
        }

        FreeProws   (psrs);
        psrs    =  NULL;
        if (pStore) {
            pStore->Release();
            pStore = NULL;
        }

        if (accountFound) {
            break;
        }
    }

FuncExit:
    if (psrs) {
        FreeProws   (psrs);
    }

    if (pStore) {
        pStore->Release();
    }

    if (pTable) {
        pTable->Release();
    }

    if (pSession) {
        pSession->Release();
    }

    return guid;
}

bool removeAccount(const wchar_t* accountId)
{
    bool            ret = true;
    LPWSTR          out = NULL;
    const wchar_t*  provisioningFmt =
        TEXT("<wap-provisioningdoc><characteristic type=\"EMAIL2\"><nocharacteristic type=\"%s\"/></characteristic></wap-provisioningdoc>");
    wchar_t         provisioningStr[512];

    if (accountId == NULL) {
        return false;
    }

    memset(provisioningStr, 0, 512*sizeof(wchar_t));
    wsprintf(provisioningStr, provisioningFmt, accountId);
    HRESULT res = DMProcessConfigXML(provisioningStr, CFGFLAG_PROCESS, &out);

    if (res != S_OK) {
        ret = false;
    }

    return ret;
}


bool cleanUpFunambolMail()
{
    bool ret = true;
    wchar_t* accountId = NULL;

    if (accountId = getFunambolAccountId()) {
        if (removeAccount(accountId) == false) {
            ret = false;
        }
        delete [] accountId;
    }

    return ret;
}

/**
* This function performs action due to the update software.
* For versions after 6.5.0 there are
*   - push changes: values are 0,1,2,3. Now for previous 2 value it is converted
*                   to 1 and askUser become 1.
*   - add flag to calculate the contact crc in the new way. It writes a flag in the registry
*     that is it checked by the program and the proper action is performed.
* For versions after Elba (6.5.x):
*   - add flag to calculate the events crc in the new way (like contact one).
* Since 7.1.2: only vCard is used for contacts, so force the contact's type.
*
* NOTE: the registry swv registry is populated properly by the 6.5.3 release.
* for the previous version this value is 0.
*/
void makeUpdateActions() {

    wchar_t* value = NULL;
    value = readPropertyValue(getFullReg(BASE_ROOT_TREE), TEXT("oldswv"));
    int previousVersion = getBuildNumberFromVersion(value);

    // to set if the previous notification has to start or not
    bool startPreviousNotificaton = true;
    if (value) { delete [] value; value = NULL; }

    // if previous version is minor then 6.5.0
    if (previousVersion < 60500) {

        // after 6.0, trash, Sent and Draft are not syncable
        // The inbox and outbox are always checked as 1 and the sync type is two-way
        setPropertyValue(ROOT_TREE_MAILS, TEXT("Trash"),  TEXT("0"));
        setPropertyValue(ROOT_TREE_MAILS, TEXT("Sent"),   TEXT("0"));
        setPropertyValue(ROOT_TREE_MAILS, TEXT("Draft"),  TEXT("0"));


        // add contact flag to calculate previous crc hash
        setPropertyValue(ROOT_TREE, TEXT("calculateContactOldCrc"),    TEXT("true"));

        // change the value of the push
        value = readPropertyValue(getFullReg(BASE_ROOT_TREE), TEXT("push"));
        if (value && wcscmp(value, TEXT("2")) == 0) {
            setPropertyValue(ROOT_TREE, TEXT("push"), TEXT("3"));
            setPropertyValue(ROOT_TREE, TEXT("askUser"), TEXT("1"));
        }
        if (value) { delete [] value; value = NULL; }

        // change the value of the sms registry
        value = readPropertyValue(getFullReg( BASE_ROOT_TREE), TEXT("sms"));
        if (value && wcscmp(value, TEXT("2")) == 0) {
            setPropertyValue(ROOT_TREE, TEXT("sms"), TEXT("1"));
        }
        if (value) { delete [] value; value = NULL; }
    }
    if (previousVersion < 60516) {
        // force to set the clientPushInterval to 5.
        setPropertyValue(ROOT_TREE, TEXT("clientPushInterval"), TEXT("5"));
    }
    // if previous version is before 6.6.0 (after Elba = 6.5.x)
    if (previousVersion < 60600) {

        // add events and task flags to calculate previous crc hash
        setPropertyValue(ROOT_TREE, TEXT("calculateEventOldCrc"),  TEXT("true"));
        setPropertyValue(ROOT_TREE, TEXT("calculateTaskOldCrc"),   TEXT("true"));

        // Added support for vTodo and vNote.
        setPropertyValue(ROOT_TREE_CONTACTS,     TEXT("supportedTypes"), TEXT("text/x-s4j-sifc:1.0,text/x-vcard:2.1"));
        setPropertyValue(ROOT_TREE_CALENDAR, TEXT("supportedTypes"), TEXT("text/x-s4j-sife:1.0,text/x-vcalendar:1.0"));
        setPropertyValue(ROOT_TREE_TASKS,        TEXT("supportedTypes"), TEXT("text/x-s4j-sift:1.0,text/x-vcalendar:1.0"));
        setPropertyValue(ROOT_TREE_NOTES,        TEXT("supportedTypes"), TEXT("text/x-s4j-sifn:1.0,text/x-vnote:1.1"));

        // Added SIF version
        value = readPropertyValue(getFullReg( BASE_ROOT_TREE  TREE_SOURCE_CONTACTS), TEXT("type"));
        if (value && !wcscmp(value, TEXT("text/x-s4j-sifc"))) {
            setPropertyValue(ROOT_TREE_CONTACTS, TEXT("version"), TEXT("1.0"));
            delete [] value;
            value = NULL;
        }
        value = readPropertyValue(getFullReg( BASE_ROOT_TREE  TREE_SOURCE_CALENDAR), TEXT("type"));
        if (value && !wcscmp(value, TEXT("text/x-s4j-sife"))) {
            setPropertyValue(ROOT_TREE_CALENDAR, TEXT("version"), TEXT("1.0"));
            delete [] value;
            value = NULL;
        }
        value = readPropertyValue(getFullReg( BASE_ROOT_TREE  TREE_SOURCE_TASKS), TEXT("type"));
        if (value && !wcscmp(value, TEXT("text/x-s4j-sift"))) {
            setPropertyValue(ROOT_TREE_TASKS, TEXT("version"), TEXT("1.0"));
            delete [] value;
            value = NULL;
        }
        value = readPropertyValue(getFullReg( BASE_ROOT_TREE  TREE_SOURCE_NOTES), TEXT("type"));
        if (value && !wcscmp(value, TEXT("text/x-s4j-sifn"))) {
            setPropertyValue(ROOT_TREE_NOTES, TEXT("version"), TEXT("1.0"));
            delete [] value;
            value = NULL;
        }

    }

    // Version 6.6.1: added config sync, and passwords ecrypted.
    if (previousVersion < 60601) {

    	value = readPropertyValue(
            getFullReg(BASE_ROOT_TREE   TREE_SOURCE_AUTH),
            TEXT("password"));
        char* c1 = toMultibyte(value);
        if (value) { delete [] value; value = NULL; }

        char* cval = encryptData(c1, NULL);
        value = toWideChar(cval);
        setPropertyValue(ROOT_TREE_AUTH, TEXT("password"), value);
        if (cval)  { delete [] cval;  cval = NULL;  }
        if (c1)    { delete [] c1;    c1 = NULL;    }
        if (value) { delete [] value; value = NULL; }

        // set the proper value for the new config sync source
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("sync"),      TEXT("none"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("last"),      TEXT("0"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("name"),      TEXT("config"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("type"),      TEXT("text/plain"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("syncModes"), TEXT("slow,two-way,refresh"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("uri"),       TEXT("configuration"));
        setPropertyValue(ROOT_TREE_CONFIG, TEXT("encoding"),  TEXT("b64"));

        // to force to sync the config parameters
        setPropertyValue(ROOT_TREE, TEXT("toSyncConfiguration"),  TEXT("1"));
    }

#ifdef IS_PORTAL_VERSION

    if (previousVersion < 70001) {
        value = readPropertyValue(
            getFullReg(BASE_ROOT_TREE   TREE_SOURCE_AUTH),
            TEXT("password"));

        char* c1   = toMultibyte(value);
        char* cval = decryptData(c1, NULL);
        delete [] c1;
        delete [] value;

        c1 = encryptData(cval, PASS_KEY);
        value = toWideChar(c1);
        setPropertyValue(ROOT_TREE_AUTH, TEXT("password"), value);

        delete [] cval;
        delete [] value;
        delete [] c1;
    }

#endif
    // commented out for the next release
    // set the signature by default

    // set the utc value to 1 to live together version v65 and v7
    if (previousVersion < 70006) {
        setPropertyValue(ROOT_TREE_EXT, TEXT("utc"), TEXT("1"));
    }

    // Since 7.1.2, vCard is the default.
    if (previousVersion < 70102) {
        // don't modify the name of the source because if previously there was card it remain the same...
        // force instead the other values
        // setPropertyValue(ROOT_TREE_CONTACTS, TEXT("uri"),      TEXT("card"));
        setPropertyValue(ROOT_TREE_CONTACTS, TEXT("type"),     TEXT("text/x-vcard"));
        setPropertyValue(ROOT_TREE_CONTACTS, TEXT("useSIF"),   TEXT("0"));
        setPropertyValue(ROOT_TREE_CONTACTS, TEXT("encoding"), TEXT("bin"));
        setPropertyValue(ROOT_TREE_CONTACTS, TEXT("version"),  TEXT("2.1"));
    }

    //
    // Here must be aligned to the latest version released. it will be the 8.0

    // modified in after 7.1.10 (the ga so at least 7.1.11)
    // the client push mechanism. Now the ClienPushManager schedules the sync
    // the default for the registry become 1 min.
    if (previousVersion < 80000) {
        setPropertyValue(ROOT_TREE, TEXT("clientPushInterval"), TEXT("1"));
    }

    // after the 7.2 and 7.3 there is the pictures sync source.
    // added the "enabled" property to all the sources. Now to understand if enabled or not
    // all are based on it.
    // At Jun 11 2009 the picture sync source is hidden and the version becomes 8.0.0 from 8.5.0.
    // So in this version 8.0.0 starts the upgrade from the 7.2.2
    if (previousVersion < 80000) {

        // remove the old parameter
        RegDeleteKey(HKEY_LOCAL_MACHINE, getFullReg(BASE_ROOT_TREE  TEXT("\\brand\\showNoteSource")));
        RegDeleteKey(HKEY_LOCAL_MACHINE, getFullReg(BASE_ROOT_TREE  TEXT("\\brand\\showBriefcaseSource")));

        // added ssl verification
        setPropertyValue(ROOT_TREE, TEXT("sslVerifyServer"), TEXT("1"));

        // conversion between sync mode and enabled
        wchar_t* value = NULL;
        // Contacts
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE  TREE_SOURCE_CONTACTS), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_CONTACTS, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_CONTACTS, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_CONTACTS, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // appointment
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE  TREE_SOURCE_CALENDAR), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_CALENDAR, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_CALENDAR, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_CALENDAR, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // task
        value = readPropertyValue(getFullRegBkp( BASE_ROOT_TREE  TREE_SOURCE_TASKS), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_TASKS, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_TASKS, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_TASKS, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // briefcase
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE  TREE_SOURCE_BRIEFCASE), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_BRIEFCASE, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_BRIEFCASE, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_BRIEFCASE, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // note
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE  TREE_SOURCE_NOTES), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_NOTES, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_NOTES, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_NOTES, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // mail
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE  TREE_SOURCE_MAILS), TEXT("sync"));
        if (value && wcscmp(value, TEXT("none")) != 0) {
            setPropertyValue(ROOT_TREE_MAILS, TEXT("enabled"), TEXT("1"));
        } else {
            setPropertyValue(ROOT_TREE_MAILS, TEXT("sync"), TEXT("two-way"));
            setPropertyValue(ROOT_TREE_MAILS, TEXT("enabled"), TEXT("0"));
        }
        if (value) { delete [] value; value = NULL; }

        // config will restore automatically

        // pictures disabled by default. This is the first time they are added
        createPictureSettings();

        // for the smartslowsync parameter
        value = readPropertyValue(getFullReg(BASE_ROOT_TREE  TEXT("\\server\\Ext")), TEXT("smartSlowSync"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE  TEXT("\\server\\Ext"), TEXT("smartSlowSync"), TEXT("1"));
        } else if (value && wcscmp(value, TEXT("1")) == 0) {
            setPropertyValue(ROOT_TREE  TEXT("\\server\\Ext"), TEXT("smartSlowSync"), TEXT("0"));
        }

        // if it is an update of the client, the acknowledge is supposed to be already known
        setPropertyValue(ROOT_TREE, TEXT("ackDataConnection"), TEXT("1"));
    }

    // clean up mail account Funambol type for MEA
    if (previousVersion < 80500) {

        // remove old Funambol account
        cleanUpFunambolMail();
        // delete cache for inbox and outbox messages
        DeleteFile(FILE1);
        DeleteFile(FILE2);
        // clean up mail source entry in config
        RegDeleteKey(HKEY_LOCAL_MACHINE, getFullReg( ROOT_TREE_MAILS) );
        // clean up old transport registry
        RegDeleteKey(HKEY_LOCAL_MACHINE, SYNCML_OLD_TRANSPORT_REGISTRY);
        // set up new transport registry
        createSyncmlTransportRegistry();
        //
        // CTP stretched params, to maximize battery life. since v.8.2.0
        //
        setPropertyValue(ROOT_TREE, TEXT("ctpRetry"),    TEXT("60"  ));
        setPropertyValue(ROOT_TREE, TEXT("maxCtpRetry"), TEXT("1200"));
        setPropertyValue(ROOT_TREE, TEXT("ctpReady"),    TEXT("600" ));
        setPropertyValue(ROOT_TREE, TEXT("ctpCmdTimeout"), TEXT("60") );

        setPropertyValue(ROOT_TREE_MAILS, TEXT("attachSize"),  TEXT("2"));
        setPropertyValue(ROOT_TREE_MAILS, TEXT("downloadAge"),  TEXT("-1"));
        setPropertyValue(ROOT_TREE_MAILS, TEXT("bodySize"),     TEXT("1"));

        //
        // encryption disabled for each source is "" (was "0")
        //
        wchar_t* value = NULL;
        // Contacts
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_CONTACTS), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_CONTACTS, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // appointments
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_CALENDAR), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_CALENDAR, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // tasks
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_TASKS), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_TASKS, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // briefcase
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_BRIEFCASE), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_BRIEFCASE, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // notes
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_NOTES), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_NOTES, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // mails
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_MAILS), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_MAILS, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // pictures
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_PICTURE), TEXT("encryption"));
        if (value && wcscmp(value, TEXT("0")) == 0) {
            setPropertyValue(ROOT_TREE_PICTURES, TEXT("encryption"), TEXT(""));
        }
        delete [] value;

        // Pictures is now enabled by default
        setPropertyValue(ROOT_TREE_PICTURES, TEXT("enabled"), TEXT("1"), false);

        // Pictures filtering on old items = off by default
        setPropertyValue(ROOT_TREE_PICTURES, TEXT("includeOldItems"), TEXT("0"), false);

        // Set the installation timestamp = right now
        WCHAR now[11];
        void* v = NULL;
        wsprintf(now, TEXT("%li"), time(v));
        setPropertyValue(ROOT_TREE, TEXT("installTimestamp"), now, false);
    }
    if (previousVersion < 80700) {

       setPropertyValue(ROOT_TREE_CALENDAR, TEXT("type"),     TEXT("text/x-vcalendar"));
       setPropertyValue(ROOT_TREE_CALENDAR, TEXT("useSIF"),   TEXT("0"));
       setPropertyValue(ROOT_TREE_CALENDAR, TEXT("encoding"), TEXT("bin"));
       setPropertyValue(ROOT_TREE_CALENDAR, TEXT("version"),  TEXT("1.0"));
       setPropertyValue(ROOT_TREE_CALENDAR, TEXT("supportedTypes"), TEXT("text/x-vcalendar:1.0,text/x-s4j-sife:1.1"));

       setPropertyValue(ROOT_TREE_TASKS, TEXT("type"),     TEXT("text/x-vcalendar"));
       setPropertyValue(ROOT_TREE_TASKS, TEXT("useSIF"),   TEXT("0"));
       setPropertyValue(ROOT_TREE_TASKS, TEXT("encoding"), TEXT("bin"));
       setPropertyValue(ROOT_TREE_TASKS, TEXT("version"),  TEXT("1.0"));
       setPropertyValue(ROOT_TREE_TASKS, TEXT("supportedTypes"), TEXT("text/x-vcalendar:1.0,text/x-s4j-sift:1.1"));

       // Since we removed the MeetingStatus field (bug 8725), the CRC results different.
       // To avoid sending all local events as modified, at first sync (bug 9781)
       setPropertyValue(ROOT_TREE, TEXT("calculateEventOldCrc"),  TEXT("true"));
    }
        
    // v.9.0.0
    if (previousVersion < 90000) {
        // Changed the syncModes param for some sources
        wchar_t* pimSyncModes       = toWideChar(PIM_DEVINFO_SYNC_MODES);
        wchar_t* picturesSyncModes  = toWideChar(PICTURES_DEVINFO_SYNC_MODES);
        wchar_t* mailSyncModes      = toWideChar(MAIL_DEVINFO_SYNC_MODES);
        setPropertyValue(ROOT_TREE_CONTACTS, TEXT("syncModes"), pimSyncModes);
        setPropertyValue(ROOT_TREE_CALENDAR, TEXT("syncModes"), pimSyncModes);
        setPropertyValue(ROOT_TREE_TASKS,    TEXT("syncModes"), pimSyncModes);
        setPropertyValue(ROOT_TREE_NOTES,    TEXT("syncModes"), pimSyncModes);
        setPropertyValue(ROOT_TREE_BRIEFCASE,TEXT("syncModes"), pimSyncModes);
        setPropertyValue(ROOT_TREE_PICTURES, TEXT("syncModes"), picturesSyncModes);
        setPropertyValue(ROOT_TREE_MAILS,    TEXT("syncModes"), mailSyncModes);

        // reset the anchor as well to force a slow sync. Put value = 2 to detect it has been forced
        // changed in the customList.cpp the check for also the 2 value
        wchar_t* value = NULL;
        value = readPropertyValue(getFullRegBkp(BASE_ROOT_TREE   TREE_SOURCE_CONTACTS), TEXT("sync"));        
        WString syncModes(value);
        if (syncModes.find(TEXT(SYNC_MODE_ONE_WAY_FROM_CLIENT)) != WString::npos ||
            syncModes.find(TEXT(SYNC_MODE_ONE_WAY_FROM_SERVER)) != WString::npos ||
            syncModes.find(TEXT("one-way-server")) != WString::npos ||
            syncModes.find(TEXT("one-way-client")) != WString::npos) {
                setPropertyValue(ROOT_TREE_CONTACTS,  TEXT("last"), TEXT("2"));
                setPropertyValue(ROOT_TREE_CALENDAR,  TEXT("last"), TEXT("2"));
                setPropertyValue(ROOT_TREE_TASKS,     TEXT("last"), TEXT("2"));
                setPropertyValue(ROOT_TREE_NOTES,     TEXT("last"), TEXT("2"));
                setPropertyValue(ROOT_TREE_BRIEFCASE, TEXT("last"), TEXT("2"));
        }
        delete [] value;

    }

    //
    // It updates the registry params that has to be done for every installation,
    // not depending on the previous version.
    //
    updateNewRegistry();

    flushRegistry();

    if (startPreviousNotificaton) {
        // Starts push/sms/cradle if selected and credentials set
        restoreNotificationSettings();
    }


}

/*************************************************************************************/
// **************************************************************************
// Function Name: Install_Init
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN BOOL fFirstCall  indicates that this is the first time this function is being called
//    IN BOOL fPreviouslyInstalled  indicates that the current application is already installed
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeINSTALL_INIT
//    returns install status
//
// Description:
//    The Install_Init function is called before installation begins.
//    User will be prompted to confirm installation.
// **************************************************************************
SETUP_API codeINSTALL_INIT Install_Init(
    HWND        hwndParent,
    BOOL        fFirstCall,     // is this the first time this function is being called?
    BOOL        fPreviouslyInstalled,
    LPCTSTR     pszInstallDir
    )
{

    // if the compile options are not smartphone but the OS is smartphone
    // exit
    if (isPluginSmartphone && !IsSmartphoneDevice()) {
        MessageBox (NULL, NO_SMARTPHONE, TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
        return codeINSTALL_INIT_CANCEL;
    } else if (!isPluginSmartphone && IsSmartphoneDevice()) {
        MessageBox (NULL, NO_POCKET_PC, TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
        return codeINSTALL_INIT_CANCEL;
    }

    //
    // This function could be called to force to close the email process
    //
    deregister();
    closeMail();
    closeFunambol();

    int res = 0;
    wchar_t nameToRemove [128];
    memset(nameToRemove, 0, 128*sizeof(wchar_t));

    if (fFirstCall) {
        if (existsFileForUpdate()) {
            deleteFileForUpdate();
        }
    } else {
        return codeINSTALL_INIT_CONTINUE;
    }

    if (fPreviouslyInstalled) {
        // copy the registry keys with their configurations
        backupClientVersion();
        createFileForUpdate();

    } else if ((res = existsPreviousVersionWithDifferentName(nameToRemove)) > 0) {

        if (res == 1) { // res = 1 is a 6.0, 6.5, 7.0 component. Removed support for older
            backupClientVersion();
            createFileForUpdate();
            removeEntryOfUninstallDifferentName(nameToRemove);

        } else {
            MessageBox (NULL, TOO_OLD_VERSION, TEXT ("Alert"),
                    MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
            return codeINSTALL_INIT_CANCEL;
        }
    }
    else {
        createAllRegistry();
        createSyncmlTransportRegistry();
    }
    //MessageBox (NULL, TEXT("Exit install init"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);

    return codeINSTALL_INIT_CONTINUE;
}


// **************************************************************************
// Function Name: Install_Exit
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeINSTALL_EXIT
//    returns install status
//
// Description:
//    Register query client with the PushRouter as part of installation.
//    Only the first two parameters really count.
// **************************************************************************
SETUP_API codeINSTALL_EXIT Install_Exit(
    HWND    hwndParent,
    LPCTSTR pszInstallDir,      // final install directory
    WORD    cFailedDirs,
    WORD    cFailedFiles,
    WORD    cFailedRegKeys,
    WORD    cFailedRegVals,
    WORD    cFailedShortcuts
    )
{
    if (!existsFileForUpdate()) {
        createBriefcaseFolder();
        Sleep(3000);
    }
    if (existsBackup()) {
        restoreClientVersion();
        //
        // actions to do if the version is an update
        // The deletion of backup is done after to allow to do some
        // action related to old values
        //
        makeUpdateActions();
        removeBackupVersion();

    }

    deleteFileForUpdate();

    // start the program automatically
    wchar_t prog[128];
    wsprintf(prog, TEXT("%s.exe"), UI_EXECUTABLE_NAME);

    PROCESS_INFORMATION proc_info;
    DWORD dwWaitRes = 0;
    DWORD timeOut = 10 * 1000; // 10 secs of timeout
    memset(&proc_info, 0, sizeof(proc_info));
    execprogram(prog, _T(" "), &proc_info);
    dwWaitRes = WaitForSingleObject(proc_info.hProcess, timeOut);

    PostMessage(hwndParent, WM_QUIT, 0, 0);

    return codeINSTALL_EXIT_DONE;
}


// **************************************************************************
// Function Name: Uninstall_Init
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeUNINSTALL_INIT
//    returns uninstall status
//
// Description:
//    Query the device data using the query xml in the push message,
//    and send the query results back to the server.
// **************************************************************************
SETUP_API codeUNINSTALL_INIT Uninstall_Init(
    HWND        hwndParent,
    LPCTSTR     pszInstallDir
    )
{

    deregister();
    deleteFiles();
    closeMail();
    closeFunambol();
    if (!existsFileForUpdate()) {
        PROCESS_INFORMATION proc_info;
        DWORD dwWaitRes = 0;
        DWORD timeOut = 10 * 1000; // 10 secs of timeout
        memset(&proc_info, 0, sizeof(proc_info));
        // start handleservice program and get its process handle
        if (execprogram( _T("handleservice.exe"), _T("deleteAccount"), &proc_info) == false) {
            return codeUNINSTALL_INIT_CONTINUE;
        }

        // wait until handleservice process has finished its initialization
        dwWaitRes = WaitForSingleObject(proc_info.hProcess, timeOut);

        // cleanup process resources
        CloseHandle(proc_info.hThread);
        CloseHandle(proc_info.hProcess);
    }

    return codeUNINSTALL_INIT_CONTINUE;
}


// **************************************************************************
// Function Name: Uninstall_Exit
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//
// Return Values:
//    codeUNINSTALL_EXIT
//    returns uninstall status
//
// Description:
//    Query the device data using the query xml in the push message,
//    and send the query results back to the server.
// **************************************************************************
SETUP_API codeUNINSTALL_EXIT Uninstall_Exit(
    HWND    hwndParent
    )
{

    if (!existsFileForUpdate()) {
        deleteSyncmlTransportRegistry();
        deleteAllRegistry();
        deleteDirectory();

    } else {
        deleteAllRegistry();
        deleteFilesInRoot();
    }

    return codeUNINSTALL_EXIT_DONE;

}


static BOOL IsSmartphoneDevice()
{
    TCHAR tszPlatform[64];

    if (TRUE == SystemParametersInfo(SPI_GETPLATFORMTYPE,
         sizeof(tszPlatform)/sizeof(*tszPlatform),tszPlatform,0))
    {
        if (0 == _tcsicmp(TEXT("Smartphone"), tszPlatform))
        {
            return TRUE;
        }
    }
    return FALSE;
}


/**
 * Returns true if syncUrl & username & password are set.
 */
bool checkCredentials() {

    bool ret = true;
    wchar_t* value = NULL;
    wchar_t connContext[MAX_PATH] = TEXT("");
    wchar_t authContext[MAX_PATH] = TEXT("");

    // Check syncUrl
    wsprintf(connContext, BASE_ROOT_TREE   TREE_SOURCE_CONN, getRegistryRoot());
    value = readPropertyValue(connContext, TEXT("syncUrl"));
    if (value) {
        if (!wcslen(value) || wcsstr(value, TEXT("<")) ) {
            ret = false;
        }
        delete [] value; value = NULL;
    }
    if (!ret) return false;


    // Check username
    wsprintf(authContext, BASE_ROOT_TREE   TREE_SOURCE_AUTH, getRegistryRoot());
    value = readPropertyValue(authContext, TEXT("username"));
    if (value) {
        if (!wcslen(value)) {
            ret = false;
        }
        delete [] value; value = NULL;
    }
    if (!ret) return false;


    // Check password
    value = readPropertyValue(authContext, TEXT("password"));
    if (value) {
        if (!wcslen(value)) {
            ret = false;
        }
        delete [] value; value = NULL;
    }

    return ret;
}
